#==========================================================================#
#  B.Forum Ver.1.01                                                      #
#  ⥸塼                                                          #
#  Encode = EUC                                                          #
#  Hiroaki,Sakuma ( sakuma@beetas.org )                                  #
#  BEETAS.org ( info@beetas.org )                                        #
#                                                                          #
# Υץꥱϥץ󥽡Ǥ.                          #
# ̵ǻѤ뤳ȤǤޤ.                                            #
# ʤ, ܺ٤ʻѾ/ǿˤĤƤϲȤ.           #
# http://www.beetas.org/                                                   #
#                                                                          #
# ------------------------------------------------------------------------ #
# Copyright 2001-2003 Hiroaki,Sakuma All Rights Reserved.                  #
# Copyright 2001-2003 BEETAS.org All Rights Reserved.                      #
#                                                                          #
#==========================================================================#
package Bforum;

$version = '1.01R-5';
$revision = '1.01.0064';
$rcfile = '.bforumrc';
#$rcfile = 'bforum.conf';

require 5.005;

use AutoLoader('AUTOLOAD');

__END__

sub main {

	my ($tmp1);

	&init;

	if (defined &plugin('main',@_)) { exit(0); }

	if ($Query[0] eq 'Check') {
		## Flush to cache
		&_cache_flush;
		$do{'nocache'} = 1;
	}

	## Caching
	$tmp1 = join('&',@Query);
	$tmp1 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
	if (-f ("$SET{'USER_DIR'}/.cache/$tmp1$browser->{browser}")) {
		print &_open(undef,("$SET{'USER_DIR'}/.cache/$tmp1$browser->{browser}"));
		exit(0);
	}

	if (!($in{'plugin'} && defined &plugin($in{'plugin'}))) {

		## Not extention plugin(default)
		if ($Query[0] eq 'Check' && $SET{'CHECK_DO'} ne 'N') {
			## Check
			&check;
		} elsif ($Query[0] eq 'Help') {
			## Help
			&help;
		} elsif (!$Query[0] && $SET{'PORTAL_DO'} ne 'N') {
			## Portal
			&portal;
		} elsif (defined $in{'search'}) {
			## Search
			&search;
		} elsif ($in{'t'}) {
			$num = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");
			if ($in{'v'}) {
				if ($in{'v'} eq 'list') {
					## List
					&list;
				} elsif ($in{'v'} eq 'tree') {
					## Tree
					&tree;
				} else {
					if ($in{'f'} eq 'f' || $in{'r'}) {
						## Replay form
						&form;
					} elsif ($in{'f'} eq 'r') {
						## Replay post
						&regist;
					} elsif ($in{'d'}) {
						## File download
						&download;
					} else {
						## View log
						&view;
					}
				}
			} else {
				if ($in{'f'} eq 'f' || $in{'r'}) {
					## Post form
					&form;
				} elsif ($in{'f'} eq 'r') {
					## Post post
					&regist;
				} else {
					## Thread
					&thread;
				}
			}
		} else {
			if ($in{'f'} eq 'f' || $in{'r'}) {
				## Create thread form
				&form;
			} elsif ($in{'f'} eq 'r') {
				## Create thread post
				&regist;
			} else {
				## Index
				&index($in{'i'});
			}
		}
	}
	## Print
	&print;
	undef @_;

}

sub init {

	my ($tmp1,$tmp2);

	$time{'start'} = (times)[0];
	$time = time;

	$cgi = $main::cgi;
	$cgi ||= $ENV{'SCRIPT_NAME'};

	$uri = $ENV{'REQUEST_URI'};
	if ($ENV{'QUERY_STRING'} && $uri !~ /\?/) { $uri .= '?' . $ENV{'QUERY_STRING'}; }
	$url = $ENV{'HTTP_HOST'} . $uri;

	## Check configuration file
	$tmp1 = (stat("./$rcfile"))[9];
	if ($tmp1 eq (split(',',&_open(0,"./$rcfile.cache")))[0] && -f "./$rcfile.cache") {
		eval("%SET = (" . &_open(1,"./$rcfile.cache") . ");");
	} else {
		## New or NotFound
		## Create file
		$tmp2 = "$tmp1,$time\n";
		&setting(\%SET,"./$rcfile","$ENV{'HOME'}/$rcfile");
		foreach (keys %SET) {
			$tmp2 .= "'$_'=>'$SET{$_}',";
		}
		&_write("./$rcfile.cache",$tmp2);
	}

	## Parse CGI paramater
	&decode;

	if (!$SET{'USER_DIR'}) { &error($TEXT{'ERROR_MSG_USER_DIR_NF'}); }

	$in{'id'} =~ s/\.\.\///g;

#	&_path($SET{'USER_DIR'});
	# User config(over write)
	if ($in{'id'}) {
		&setting(\%SET,"$SET{'USER_DIR'}/$in{'id'}/$rcfile");
		# System user config(over write)
		setting(\%SET,"/etc/bforum/$in{'id'}/$rcfile");
	}
	# System config(over write)
	&setting(\%SET,"/etc/bforum/$rcfile");

	## Default value
	$SET{'LANGUAGE'} ||= "ja";
	$SET{'COMPRESS_LEVEL'} ||= 1;
	$SET{'LOCK_RETRY'} ||= 5;
	$SET{'LOCK_FREE'} ||= 60;
	$SET{'COOKIE_TIME'} ||= 90 * 60 * 60 * 24;
	$SET{'TIME_FORMAT'} ||= "%YYYY/%MM/%DD %hh:%mm";
	$SET{'MONTH_FORMAT'} ||= "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec";
	$SET{'WEEK_FORMAT'} ||= "Sun,Mon,Thu,Wed,Thu,Fri,Sat";
	$SET{'AP_FORMAT'} ||= "AM,PM";
	$SET{'TIME_ZONE'} ||= "JST-9";
	$SET{'INDEX_NUMBER'} ||= 40;
	$SET{'LIST_NUMBER'} ||= 40;
	$SET{'TREE_NUMBER'} ||= 40;
	$SET{'DISP_BACK_NL'} ||= $SET{'DISP_BACK'};
	$SET{'DISP_NEXT_NL'} ||= $SET{'DISP_NEXT'};
	$SET{'DISP_INDEX_BACK_NL'} ||= $SET{'DISP_INDEX_BACK'};
	$SET{'DISP_INDEX_NEXT_NL'} ||= $SET{'DISP_INDEX_NEXT'};
	$SET{'DISP_LIST_NL'} ||= $SET{'DISP_LIST'};
	$SET{'DISP_LIST_BACK_NL'} ||= $SET{'DISP_LIST_BACK'};
	$SET{'DISP_LIST_NEXT_NL'} ||= $SET{'DISP_LIST_NEXT'};
	$SET{'DISP_TREE_NL'} ||= $SET{'DISP_TREE'};
	$SET{'DISP_TREE_BACK_NL'} ||= $SET{'DISP_TREE_BACK'};
	$SET{'DISP_TREE_NEXT_NL'} ||= $SET{'DISP_TREE_NEXT'};
	$SET{'TREE_STAGE'} ||= "ul";

	## Language import
	&language;

	&browser;

	if ($SET{'NKF'} || $SET{'JCODE'}) {
		if ($code[1] || $in{'f'} eq 'r' || $in{'f'} eq 'f' || $Query[0] eq 'Check') {
			if (%in) {
				foreach (keys %in) {
					&code(\$in{$_},'euc');
				}
			}
		}
	}

	## åǥ쥯ȥå
	## NTǺƹͤ;Ϥ
#	if ($SET{'CACHE_DO'} ne 'N' && !-w "$SET{'USER_DIR'}/.cache") { &error($TEXT{'ERROR_MSG_CACHE'}); }

}

sub portal {

	$portal = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.portal$browser->{browser}","$SET{'USER_DIR'}/BF.portal$browser->{browser}");

	if (defined &plugin('portal',@_)) { return; }

	my ($tmp1,$tmp2);

	$tmp1 = $portal;

	while ($portal =~ /{(.+?):(.+?)}/go) {
		undef %status;
		&_analysis(\%status,&_open(undef,"$SET{'USER_DIR'}/$1/status"));
		$tmp2 = "$1:$2";
		if (%status) {
			if ($2 eq 'url') {
				$print{$tmp2} = $cgi . '?' . $1;
			} elsif ($2 eq 'thread') {
				$print{$tmp2} = $status{'thread'};
			} elsif ($2 eq 'log') {
				$print{$tmp2} = $status{'log'};
			} elsif ($2 eq 'date') {
				$print{$tmp2} = &_time($status{'date'});
			} elsif ($2 =~ /date:(.+)/o) {
				$print{$tmp2} = &_time($status{'date'},$1);
			} else {
				$print{$tmp2} = "";
			}
		} else {
			$print{$tmp2} = "$SET{'USER_DIR'}/$1/status";
		}
	}

	&change($tmp1,\%print);
	undef %print;

	$do{'nocache'} = 1;
	$print .= $tmp1;

}

sub create {

	if (defined &plugin('create',@_)) { return; }

	if (-d "$SET{'USER_DIR'}/$in{'id'}" && -z "$SET{'USER_DIR'}/$in{'id'}/index") {
		$in{'t'} = ((stat "$SET{'USER_DIR'}/$in{'id'}/index")[9] || $time);
		&_analysis(\%create,&_open(undef,"$SET{'USER_DIR'}/.default")) || &error;
		$create{'message'} =~ s/\n<br>\n/\n/go;
		chomp ($create{'message'});
		$create{'new'} = "Author: $create{'author'}\n";
		$create{'new'} .= "Email: $create{'email'}\n";
		$create{'new'} .= "Title: $create{'title'}\n";
		$create{'new'} .= "No: 1\n";
		$create{'new'} .= "Host: System\n";
		$create{'new'} .= "Agent: System\n";
		$create{'new'} .= "Date: $in{'t'}\n\n";
		$create{'new'} .= $create{'message'};

		$no = 1;

		if (&_lock) {

			&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1",$create{'new'});
			&_write("$SET{'USER_DIR'}/$in{'id'}/index","$in{'t'}\n");
			&_write("$SET{'USER_DIR'}/$in{'id'}/last",$create{'new'});
			&_write("$SET{'USER_DIR'}/$in{'id'}/0",$create{'new'});
			&_flush("$SET{'USER_DIR'}/$in{'id'}/0");
			&mknmz;
			if (-f "$SET{'USER_DIR'}/$in{'id'}/0") { unlink ("$SET{'USER_DIR'}/$in{'id'}/0") || &error; }

			&status;
			&_unlock;

		}

		return ("$in{'t'}\n");

	} else {

		&about;

	}
}

sub about {

	my ($tmp1);

	$tmp1 = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.about$browser->{browser}","$SET{'USER_DIR'}/BF.about$browser->{browser}");

	$print{'url'} = $ENV{'HTTP_HOST'} . $ENV{'REQUEST_URI'};
	if ($ENV{'QUERY_STRING'} && $print{'url'} !~ /\?/) { $print{'url'} .= '?' . $ENV{'QUERY_STRING'}; }

	&change($tmp1,\%print);
	undef %print;

	&do($tmp1);

	$print = $tmp1;

	if ($_[0]) { $WARNING{'about'} = "\[$_[0]\]"; }
	$WARNING{'about'} .= "Called by " . (caller)[2] . '@' . (caller)[1];

	$do{'nocache'} = 1;

	&print;

}

sub index {

	$head = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.index.head$browser->{browser}","$SET{'USER_DIR'}/BF.index.head$browser->{browser}");
	$foot = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.index.foot$browser->{browser}","$SET{'USER_DIR'}/BF.index.foot$browser->{browser}");
	$index = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.index$browser->{browser}","$SET{'USER_DIR'}/BF.index$browser->{browser}");

	if (defined &plugin('index',@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	my (@tmp6);
	@tmp6 = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/index");
	if (!@tmp6) { @tmp6 = (&create); }

	if (defined $in{'s'} && $in{'s'} <= 1) { &about; }
	$in{'s'} ||= 1;
	$tmp1 = 0;
	$line = 0;
	while (1) {

		$in{'t'} = $tmp6[$tmp1];

		chomp($in{'t'});
		if (!$in{'t'}) { last; }

		if (!-f "$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1" && !-f "$SET{'USER_DIR'}/$in{'id'}/$in{'t'}.0.bfa")  {
			splice (@tmp6,$tmp1,1);
			next;
		}


		$tmp1 ++;

		if ($tmp1 > ($in{'s'} * $SET{'INDEX_NUMBER'})) {
			last;
		} elsif ($tmp1 > (($in{'s'} - 1) * $SET{'INDEX_NUMBER'})) {

			$line++;

			undef %index;

			$index{'number'} = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list") + 1;
			(undef,$index{'thread'},$index{'author'},undef,$index{'date:thread'},undef) = &_analysis(undef,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1"));
			(undef,undef,undef,undef,$index{'date:last'},undef) = &_analysis(undef,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$index{'number'}"));

			&_analysis(\%index,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1"));

			$index{'new'} = "";
			if ($index{'date:last'} + $SET{'NEW_TIME'} > $time) {
				$index{'new'} = $SET{'NEW_ELEM'};
				$do{'nocache'} = 1;
			}
			if ($index =~ /{date:thread:(.+?)}/o) { $index{"date:thread:$1"} = &_time($index{'date:thread'},$1); }
			if ($index =~ /{date:last:(.+?)}/o) { $index{"date:last:$1"} = &_time($index{'date:last'},$1); }
			&_time($index{'date:thread'});
			&_time($index{'date:last'});

			if ($index =~ /{thread\((.+?)\)}/o) { $index{"thread($1)"} = &_link("id=$in{'id'}&t=$in{'t'}",&_cut($index{'full_title'},$1,'...')); }
			if ($index =~ /{title\((.+?)\)}/o) { $index{"title($1)"} = &_cut($index{'full_title'},$1,'...'); }
			$index{'thread'} = &_link("id=$in{'id'}&t=$in{'t'}",$index{'thread'});
			$index{'thread:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}";
			$tmp2 = $index;
			&do($tmp2);
			&change($tmp2,\%index);
			$tmp3 .= $tmp2;

		}

	}

	if ((($in{'s'} - 1) * $SET{'INDEX_NUMBER'}) >= (@tmp6)) { &about; }
	if ($in{'s'} < 2) {
		$print{'back'} = $SET{'DISP_INDEX_BACK_NL'};
	} else {
		if ($in{'s'} == '2') {
			$print{'back'} = &_link($in{'id'},$SET{'DISP_INDEX_BACK'});
		} else {
			$print{'back'} = &_link("id=$in{'id'}&s=" . ($in{'s'} - 1),$SET{'DISP_INDEX_BACK'});
		}
	}
	if (($in{'s'} * $SET{'INDEX_NUMBER'}) >= (@tmp6)) {
		$print{'next'} = $SET{'DISP_INDEX_NEXT_NL'};
	} else {
		$print{'next'} = &_link("id=$in{'id'}&s=" . ($in{'s'} + 1),$SET{'DISP_INDEX_NEXT'});
	}

	## 硼ȥå
	$print{'page'} = $SET{'DISP_INDEX_PAGE_BEGIN'};
	if (@tmp6 % $SET{'INDEX_NUMBER'}) {
		$tmp5 = int(@tmp6 / $SET{'INDEX_NUMBER'}) + 1;
	} else {
		$tmp5 = int(@tmp6 / $SET{'INDEX_NUMBER'});
	}
	foreach (1 .. $tmp5) {

		if ($_ == $in{'s'}) {
			$print{'page'} .= $_;
		} else {
			if ($_ == 1) {
				$print{'page'} .= &_link($in{'id'},$_);
			} else {
				$print{'page'} .= &_link("id=$in{'id'}&s=" . $_,$_);
			}
		}

		if ($tmp5 ne $_) {
			## ǸǤϤʤ
			$print{'page'} .= $SET{'DISP_INDEX_PAGE_BAR'};
		}

	}
	$print{'page'} .= $SET{'DISP_INDEX_PAGE_END'};


	$tmp4 = $head . $tmp3 . $foot;
	&change($tmp4,\%print);
	undef %print;

	&_hyperlink($head,'{url:thread}',"$cgi?id=$in{'id'}&i=thread");
	&_hyperlink($head,'{url:number}',"$cgi?id=$in{'id'}&i=number");
	&_hyperlink($head,'{url:no}',"$cgi?id=$in{'id'}&i=no");
	&_hyperlink($head,'{url:last}',"$cgi?$in{'id'}");
	&_hyperlink($head,'{url:see}',"$cgi?id=$in{'id'}&i=see");

	$print .= $tmp4;
}

sub thread {

	if (defined &plugin('thread',@_)) { return; }

	&view;
	&list;
}

sub view {

	if($in{'v'}) {
		$view = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.view$browser->{browser}","$SET{'USER_DIR'}/BF.view$browser->{browser}");
	} else {
		$in{'v'} = 1;
		$view = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.thread.head$browser->{browser}","$SET{'USER_DIR'}/BF.thread.head$browser->{browser}");
	}

	if (defined &plugin('view',@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	if (!&_indexcheck) { &about; }

	&_analysis(\%view,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$in{'v'}"));

	if (!$view{'no'}) { &about; }

	$view{'number'} = $num + 1;

	$view{'new'} = "";
	if ($view{'date'} + $SET{'NEW_TIME'} > $time) {
		$view{'new'} = $SET{'NEW_ELEM'};
		$do{'nocache'} = 1;
	}
	if ($view =~ /{date:(.+?)}/o) { $view{"date:$1"} = &_time($view{'date'},$1); }
	&_time($view{'date'});

	if ($view{'delete'} || !&_listcheck($in{'v'})) {
		$view{'title'} = '()' . $view{'title'};
		&_analysis(\%view,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.delete$browser->{browser}","$SET{'USER_DIR'}/BF.delete$browser->{browser}"));
		$view{'email'} = $SET{'ADDRESS'};
	}

	if ($view =~ /{title\((.+?)\)}/o) { $view{"title($1)"} = &_cut($view{'full_title'},$1,'...'); }

	&tag($view{'message'});

	&_autolink($view{'message'});

	# HTML -> XHTML
	&_xhtmlcheck($view{'message'});

	$view{'message'} =~ s/(^|\n)(\s*(&gt;[(&gt;)(\s*)]*)[^\n]*)/$1<span style="color:#990000">$2<\/span>/go;
	$view{'message'} =~ s/(^|\n)(\s*([()(\s*)]*)[^\n]*)/$1<span style="color:#990000">$2<\/span>/go;
	$view{'message'} =~ s/(^|\n)(\s*(#[#(\s*)]*)[^\n]*)/$1<span style="color:#009900">$2<\/span>/go;

	$tmp2 = int(($in{'v'} - 1) / $SET{'LIST_NUMBER'}) + 1;

	if ($in{'v'} eq '1') {
		$tmp3 = 1;
		$in{'s'} ||= 1;
	} else {
		$tmp1 = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");
		foreach (0 .. $tmp1) {
			if ($in{'v'} eq (split(/<0>/,&_open($_,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[0]) {
				$tmp3 = int(($tmp1 - $_) / $SET{'TREE_NUMBER'}) + 1;
				last;
			}
		}
	}

	$tmp4 = $view;

	&do($tmp4);
	&change($tmp4,\%view);

	if ($in{'v'} <= 1) {
		$print{'back'} = $SET{'DISP_BACK_NL'};
	} else {
		$tmp5 = $in{'v'} - 1;
		$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&v=$tmp5",$SET{'DISP_BACK'});
	}

	if ($in{'v'} >= $view{'number'}) {
		$print{'next'} = $SET{'DISP_NEXT_NL'};
	} else {
		$tmp5 = $in{'v'} + 1;
		$print{'next'} = &_link("id=$in{'id'}&t=$in{'t'}&v=$tmp5",$SET{'DISP_NEXT'});
	}

	if (!$_[0] && $view{'number'} ne '1') {
		$print{'tree'} = &_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=$tmp3",$SET{'DISP_TREE'});
	} else {
		$print{'tree'} = $SET{'DISP_TREE_NL'};
	}
	$print{'list:url'} = "id=$in{'id'}&t=$in{'t'}&v=list&s=$tmp2";
	$print{'tree:url'} = "id=$in{'id'}&t=$in{'t'}&v=tree&s=$tmp3";
	$print{'list'} = &_link("id=$in{'id'}&t=$in{'t'}&v=list&s=$tmp2",$SET{'DISP_LIST'});

	&change($tmp4,\%print);
	undef %print;

	$print .= $tmp4;

}

sub download {

	my ($tmp1);

	$in{'d'} =~ s/\/(.*)/$1/g;

	$tmp1 = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/files/$in{'t'}/$in{'v'}/$in{'d'}");

	if ($do{'nobody'}) {
		$tmp1 = (split(/\n{2}/,$tmp1))[0];
	}

	if ($tmp1) {
		select (STDOUT);
		binmode (STDOUT);
		print $tmp1;
		exit(0);
	} else {
		&about;
	}

}

sub tree {

	$head = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.tree.head$browser->{browser}","$SET{'USER_DIR'}/BF.tree.head$browser->{browser}");
	$foot = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.tree.foot$browser->{browser}","$SET{'USER_DIR'}/BF.tree.foot$browser->{browser}");
	$tree = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.tree$browser->{browser}","$SET{'USER_DIR'}/BF.tree$browser->{browser}");

	if (defined &plugin('tree',@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	if (!&_indexcheck) { &about; }

	if (defined $in{'s'} && $in{'s'} < 1) { &about; }
	$in{'s'} ||= 1;
	$tmp1 = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list") + 1;
	$tmp2 = $tmp1 - ($in{'s'} - 1) * $SET{'TREE_NUMBER'};
	$line = 0;
	foreach (reverse(1 .. $SET{'TREE_NUMBER'})) {

		$tree{'number'} = (split(/<0>/,&_open(($tmp2 - $_),"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[0] || 1;
		if (0 > ($tmp2 - $_)) { next; }

		$line++;

		&_analysis(\%tree,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$tree{'number'}"));

		if ($tree{'number'} == 1) {
			$stage[$tree{'number'}] = (split(/<0>/,&_open(($tmp2 - $_),"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[1];
		} else {
			$stage[$tree{'number'}] = (split(/<0>/,&_open(($tmp2 - $_),"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[1] + 1;
		}

		$tree{'new'} = "";
		if ($tree{'date'} + $SET{'NEW_TIME'} > $time) {
			$tree{'new'} = $SET{'NEW_ELEM'};
			$do{'nocache'} = 1;
		}
		if ($tree =~ /{date:(.+?)}/o) { $tree{"date:$1"} = &_time($tree{'date'},$1); }
		&_time($tree{'date'});
		if ($tree{'delete'}) {
			$tree{'title'} = '()' . $tree{'title'};
			&_analysis(\%tree,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.delete$browser->{browser}","$SET{'USER_DIR'}/BF.delete$browser->{browser}"));
			$tree{'email'} = $SET{'ADDRESS'};
		}
		if ($tree =~ /{title:(.+?)}/o) { $tree{"title:$1"} = &_link("id=$in{'id'}&t=$in{'t'}&v=$tree{'no'}",&_cut($tree{'full_title'},$1,'...')); }
		$tree{'title'} = &_link("id=$in{'id'}&t=$in{'t'}&v=$tree{'no'}",$tree{'title'});

		$tmp3 = ("<$SET{'TREE_STAGE'}>" x $stage[$tree{'number'}]) . $tree . ("</$SET{'TREE_STAGE'}>" x $stage[$tree{'number'}]);
		&do($tmp3);
		&change($tmp3,\%tree);
		$tmp4 .= $tmp3;

	}

	if ((($in{'s'} - 1) * $SET{'TREE_NUMBER'}) >= $tmp1) { &about; }

	if ($in{'s'} < 2) {
		$print{'back'} = $SET{'DISP_TREE_BACK_NL'};
	} else {
		if ($in{'s'} == 1) {
			$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&v=tree",$SET{'DISP_TREE_BACK'});
		} else {
			$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=" . ($in{'s'} - 1),$SET{'DISP_TREE_BACK'});
		}
	}
	if (($in{'s'} * $SET{'TREE_NUMBER'}) >= $tmp1) {
		$print{'next'} = $SET{'DISP_TREE_NEXT_NL'};
	} else {
		$print{'next'} = &_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=" . ($in{'s'} + 1),$SET{'DISP_TREE_NEXT'});
	}

	$print{'list'} = &_link("id=$in{'id'}&t=$in{'t'}&v=list&s=1",$SET{'DISP_LIST'});
	$print{'tree'} = $SET{'DISP_TREE_NL'};

	## 硼ȥå
	$print{'page'} = $SET{'DISP_TREE_PAGE_BEGIN'};
	foreach (1 .. (int(($tmp1 - (1 % $SET{'TREE_NUMBER'}) - 1) / $SET{'TREE_NUMBER'}) + 1)) {

		if ($_ == $in{'s'}) {
			$print{'page'} .= $_;
		} else {
			$print{'page'} .= &_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=" . $_,$_);
		}

		if ((int(($tmp1 - (1 % $SET{'TREE_NUMBER'}) - 1) / $SET{'TREE_NUMBER'}) + 1) ne $_) {
			## ǸǤϤʤ
			$print{'page'} .= $SET{'DISP_TREE_PAGE_BAR'};
		}

	}
	$print{'page'} .= $SET{'DISP_TREE_PAGE_END'};


	$tmp5 = $head . $tmp4 . $foot;
	&change($tmp5,\%print);
	undef %print;

	$print .= $tmp5;
}

sub list {

	if ($in{'v'} eq 'list') {
		$head = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.list.head$browser->{browser}","$SET{'USER_DIR'}/BF.list.head$browser->{browser}");
		$foot = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.list.foot$browser->{browser}","$SET{'USER_DIR'}/BF.list.foot$browser->{browser}");
		$list = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.list$browser->{browser}","$SET{'USER_DIR'}/BF.list$browser->{browser}");
	} else {
		$head = undef;
		$foot = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.thread.foot$browser->{browser}","$SET{'USER_DIR'}/BF.thread.foot$browser->{browser}");
		$list = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.thread$browser->{browser}","$SET{'USER_DIR'}/BF.thread$browser->{browser}");
	}

	if (defined &plugin('list',@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4);

	if (!&_indexcheck) { &about; }

	if ($in{'s'} < 1) { &about; }
	$in{'s'} ||= 1;
	$line = 0;
	foreach (reverse ((($in{'s'} - 1) * $SET{'LIST_NUMBER'} + 1) .. ($in{'s'} * $SET{'LIST_NUMBER'}))) {
		undef %list;
		if (&_analysis(\%list,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$_")) && $list{'no'}) {

			$line++;

			$list{'new'} = "";
			if ($list{'date'} + $SET{'NEW_TIME'} > $time) {
				$list{'new'} = $SET{'NEW_ELEM'};
				$do{'nocache'} = 1;
			}
			if ($list =~ /{date:(.+?)}/o) { $list{"date:$1"} = &_time($list{'date'},$1); }
			&_time($list{'date'});
			if ($list{'delete'} || !&_listcheck($_)) {
				$list{'title'} = '()' . $list{'title'};
				&_analysis(\%list,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.delete$browser->{browser}","$SET{'USER_DIR'}/BF.delete$browser->{browser}"));
				$list{'email'} = $SET{'ADDRESS'};
			}
			if ($list =~ /{title:(.+?)}/o && $1 =~ /^\d*$/o) { $list{"title:$1"} = &_link("id=$in{'id'}&t=$in{'t'}&v=$list{'no'}",&_cut($list{'full_title'},$1,'...')); }
			$list{'title:nl'} = $list{'full_title'};
			$list{'title'} = &_link("id=$in{'id'}&t=$in{'t'}&v=$list{'no'}",$list{'title'});

			$tmp1 = $list;
			&do($tmp1);
			&change($tmp1,\%list);

			$tmp2 .= $tmp1;

		}
	}


	$tmp4 = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");

	if ((($in{'s'} - 1) * $SET{'LIST_NUMBER'}) > ($tmp4 + 1)) { &about; }

	if ($in{'s'} == 1) {
		$print{'back'} = $SET{'DISP_LIST_BACK_NL'};
	} else {
		$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&v=list&s=" . ($in{'s'} - 1),$SET{'DISP_LIST_BACK'});
	}
	if ($in{'s'} > int($tmp4 / $SET{'LIST_NUMBER'})) {
		$print{'next'} = $SET{'DISP_LIST_NEXT_NL'};
	} else {
		$print{'next'} = &_link("id=$in{'id'}&t=$in{'t'}&v=list&s=" . ($in{'s'} + 1),$SET{'DISP_LIST_NEXT'});
	}

	if ($in{'v'} eq 'list') { $print{'list'} = $SET{'DISP_LIST_NL'}; }
	if (!$num) {
		$print{'tree'} = $SET{'DISP_TREE_NL'};
	} else {
		$print{'tree'} = &_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=1",$SET{'DISP_TREE'});
	}

	## 硼ȥå
	$print{'page'} = $SET{'DISP_LIST_PAGE_BEGIN'};
	foreach (1 .. (int(($tmp4 - (1 % $SET{'LIST_NUMBER'})) / $SET{'LIST_NUMBER'}) + 1)) {

		if ($_ == $in{'s'}) {
			$print{'page'} .= $_;
		} else {
			$print{'page'} .= &_link("id=$in{'id'}&t=$in{'t'}&v=list&s=" . $_,$_);
		}

		if ((int(($tmp4 - (1 % $SET{'LIST_NUMBER'})) / $SET{'LIST_NUMBER'}) + 1) ne $_) {
			## ǸǤϤʤ
			$print{'page'} .= $SET{'DISP_LIST_PAGE_BAR'};
		}

	}
	$print{'page'} .= $SET{'DISP_LIST_PAGE_END'};


	$tmp3 = $head . $tmp2 . $foot;
	&change($tmp3,\%print);
	undef %print;

	$print .= $tmp3;
}

sub search {
	$head = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.search.head$browser->{browser}","$SET{'USER_DIR'}/BF.search.head$browser->{browser}");
	$foot = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.search.foot$browser->{browser}","$SET{'USER_DIR'}/BF.search.foot$browser->{browser}");
	$search = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.search$browser->{browser}","$SET{'USER_DIR'}/BF.search$browser->{browser}");

	if (defined &plugin('search',@_)) { return; }

	my ($tmp1,$tmp2);

	if ($SET{'NAMAZU_INDEX'} && $SET{'NAMAZU'}) {

		foreach (split(/&/,$in{'target'})) {
			$tmp1 .= "+$_:\"$in{'search'}\" or ";
		}

		print "Location: $SET{'NAMAZU'}?query=$tmp1&whence=$in{'whence'}&idxname=$SET{'NAMAZU_INDEX'}&max=$in{'max'}&result=normal&sort=score\n\n";
		exit(0);

	} else {

		$tmp2 = &_open(2,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser->{browser}","$SET{'USER_DIR'}/BF.error$browser->{browser}");
		$tmp2 ||= "ˤбƤޤ";

	}

	$print .= $head . $tmp2 . $foot;

}

sub form {

	$form = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.form$browser->{browser}","$SET{'USER_DIR'}/BF.form$browser->{browser}");

	if (defined &plugin('form',@_)) { return; }

	my ($tmp1);

	if ($SET{'POST_DO'} eq 'N') {
		$form = &_open(7,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser->{browser}","$SET{'USER_DIR'}/BF.error$browser->{browser}") || "<b>ѤꤵƤ뤿ᡤ񤭹ߤǤޤ</b>";
	} elsif (&limit) {
		$form = &_open(3,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser->{browser}","$SET{'USER_DIR'}/BF.error$browser->{browser}") || "<b>ե뤬ͤĶᡤ񤭹ߤǤޤ</b>";
	}

	$in{'f'} = 'r';

	&_get_cookie;

	$tmp1 = $form;

	if ($in{'v'}) { &view; }
	if ($in{'t'}) { $tmp1 =~ s/{tree}/&_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=$in{'s'}",$SET{'DISP_TREE'})/ego; }

	$in{'message'} =~ s/\\n/\n/go;

	$do{'nocache'} = 1;

	$print .= $tmp1;
}

sub confirm {

	$confirm = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.confirm$browser->{browser}","$SET{'USER_DIR'}/BF.confirm$browser->{browser}");

	if (defined &plugin('confirm')) { return; }

	my ($tmp1);

	%confirm = %in;

	&_br($confirm{'message'});

	&tag($confirm{'message'});

	&_autolink($confirm{'message'});

	# HTML -> XHTML
	&_xhtmlcheck($cnfirm{'message'});

	$confirm{'message'} =~ s/(^|\n)(\s*(&gt;[(&gt;)(\s*)]*)[^\n]*)/$1<span style="color:#990000">$2<\/span>/go;
	$confirm{'message'} =~ s/(^|\n)(\s*([()(\s*)]*)[^\n]*)/$1<span style="color:#990000">$2<\/span>/go;
	$confirm{'message'} =~ s/(^|\n)(\s*(#[#(\s*)]*)[^\n]*)/$1<span style="color:#009900">$2<\/span>/go;

	$tmp1 = $confirm;

	foreach (sort keys %in) {
		if ($_ ne 'confirm' && $_ ne 'f' && $_ ne 'id' && $_ ne 't' && $_ ne 'v' && $_ ne 'cc' && $_ ne 'plugin') {
			$tmp2 .= "<input type=\"hidden\" name=\"nd.$_\" />\n";
			$in{('nd.' . $_)} = $in{$_};
			$in{('nd.' . $_)} =~ s/&amp;/&/go;
			$in{('nd.' . $_)} =~ s/&lt;/</go;
			$in{('nd.' . $_)} =~ s/&gt;/>/go;
			$in{('nd.' . $_)} =~ s/&quot;/"/go;
			$in{('nd.' . $_)} =~ s/\\\\/\\/go;
			$in{('nd.' . $_)} =~ s/(\W)/'%' . unpack("H2",$1)/ego;
		}
	}

	foreach (sort keys %files) {
		$tmp2 .= "<input type=\"hidden\" name=\"file.$_\" />\n";
		$in{('file.' . $_)} = $files{$_};
		$in{('file.' . $_)} =~ s/(\W)/'%' . unpack("H2",$1)/ego;
	}

	$confirm{'passwd'} = "*" x length($confirm{'passwd'});

	$tmp1 =~ s/<form (.*?)action=(["']?)($cgi|{cgi})\2(.*?)>(.*?)\n/<form $1action=$2$3$2$4>$5\n$tmp2/io;

	&do($tmp1);
	&change($tmp1,\%confirm);

	$print .= $tmp1;
	&print;

}

sub regist {

	$regist = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.regist$browser->{browser}","$SET{'USER_DIR'}/BF.regist$browser->{browser}");

	if (defined &plugin('regist',@_)) { return; }

	if (&limit || $SET{'POST_DO'} eq 'N') {
		&form;
		undef @_;
		return;
	} else {

		my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);
		my (@tmp7,@tmp8);
		my (@index,@list);

		foreach (split(',',$SET{'INDISPENSABLE'})) {
			if (!$in{$_} && !$in{('nk.' . $_)}) {
				$error{$_} = 1;
				$notice .= &_open(4,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser->{browser}","$SET{'USER_DIR'}/BF.error$browser->{browser}") || "<b>ɬܹܤϤƤޤ</b>\n";
				last;
			}
		}

		if (($in{'email'} && $in{'email'} !~ /\S+\@\S+\.\S+/) || ($in{'nk.email'} && $in{'nk.email'} !~ /\S+\@\S+\.\S+/)) {
			$error{'email'} = 1;
			$notice .= &_open(6,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser->{browser}","$SET{'USER_DIR'}/BF.error$browser->{browser}") || "<b>᡼륢ɥ쥹Ǥ</b>\n";
		}

		if ($SET{'FILE_UPLOAD_DO'} ne 'N') {
			## Check filesize

			foreach (keys %files) {

				if ($SET{('FILE_UPLOAD_LIMIT_' . uc($_))}) {

					## Personal
					if ($SET{('FILE_UPLOAD_LIMIT_' . uc($_))} < length((split(/\n{2}/,$files{$_}))[1])) {
						$error{$_} = 1;
						$notice .= &_open(5,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser->{browser}","$SET{'USER_DIR'}/BF.error$browser->{browser}") || "<b>åץɤե̤ͤĶƤޤ</b>\n";
					}

				} elsif ($SET{'FILE_UPLOAD_LIMIT'}) {

					## Common
					if ($SET{'FILE_UPLOAD_LIMIT'} < length((split(/\n{2}/,$files{$_}))[1])) {
						$error{$_} = 1;
						$notice .= &_open(5,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser->{browser}","$SET{'USER_DIR'}/BF.error$browser->{browser}") || "<b>åץɤե̤ͤĶƤޤ</b>\n";
					}

				}

			}

		} else {

			if (%files) {
				$error{'files'} = 1;
				$notice .= &_open(8,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser->{browser}","$SET{'USER_DIR'}/BF.error$browser->{browser}") || "<b>åץɤϻѤǤޤ</b>\n";
			}

		}

		if (%error) {
			$notice .= &_open(0,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser->{browser}","$SET{'USER_DIR'}/BF.error$browser->{browser}") || "<b>顼ΰٽ񤭹ޤǤ</b>\n";
			undef $in{'passwd'};
			&form;
		} else {

			&_analysis(\%check,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/last"));
			$check{'message'} =~ s/\n<br>\n/\n/gio;
			chomp ($check{'message'});
			if ($in{'author'} eq $check{'author'} && $in{'title'} eq $check{'title'} && $in{'message'} eq $check{'message'}) {
				if ($in{'t'}) {
					print "Location: $cgi?id=$in{'id'}&t=$in{'t'}&v=$check{'no'}\n\n";
				} else {
					print "Location: $cgi?$in{'id'}\n\n";
				}
				exit(0);
			}

			if ($in{'confirm'}) { &confirm; }

			foreach (sort keys %in) {
				if ($_ =~ s/nk\.//o) {
					$in{$_} = $in{"nk.$_"};
					undef $in{"nk.$_"};
				}
				if ($_ eq 'f' || $_ eq 'id' || $_ eq 'message' || $_ eq 't' || $_ eq 'v' || $_ eq 'cc' || $_ eq 'plugin') { next; }
				if ($_ eq 'passwd') {
					next;
				}
				my ($tmp1);
				$tmp1 = lc ($_);
				$tmp1 = ucfirst ($tmp1);
				$log .= "$tmp1: $in{$_}\n";
			}

			$host = $ENV{'REMOTE_HOST'};
			$addr = $ENV{'REMOTE_ADDR'};
			if ($host eq $addr || $host eq '') { $host = gethostbyaddr(pack("C4",split('.',$addr)),2); }
			if ($host eq '') { $host = $addr; }

#			if (!-d "$SET{'USER_DIR'}/$in{'id'}/$in{'t'}" && !-f "$SET{'USER_DIR'}/$in{'id'}/$in{'t'}.0.bfa") {
			if (!$in{'t'}) {
				$no = 1;
			} else {
				$no = $num + 2;
			}

			foreach (keys %files) {
				$tmp5 = $_;
				$tmp5 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
				$in{'files'} .= "$tmp5, ";
			}


			$log .= "No: $no\n";
			$log .= "Host: $host\n";
			$log .= "Agent: $ENV{'HTTP_USER_AGENT'}\n";
			$log .= "Version: $version(Revision:$revision)\n";
			$log .= "Date: $time\n";
			$log .= "Files: $in{'files'}\n";
			$log .= "Referer: $in{'v'}\n";
			$log .= "\n$in{'message'}\n";

			if(&_lock) {

				if (!$in{'t'}) {
					$in{'t'} = $time;
					&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1",$log);

				} else {

					&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$no",$log);

					@list = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list",">$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");

					if ($in{'v'} && $in{'v'} ne '1') {
						$tmp1 = 0;
						$tmp2 = 0;
						foreach (@list) {
							$tmp2 ++;
							@tmp7 = split (/<0>/,$_);
							if ($tmp7[0] eq $in{'v'}) {
								$tmp7[1] ++;
								splice (@list,$tmp2,undef,"$no<0>$tmp7[1]<0>\n");
								last;
							}
						}
					} else {
						unshift (@list,"$no<0>0<0>\n");
					}

					&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list",@list);

				}

				@index = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/index");
				if (!@index) { &error; }

				if ($SET{'INDEX_SORT_DO'} ne 'N' || $no eq '1') {
					$tmp3 = 0;
					foreach (@index) {
						$tmp4 = $_;
						chomp($tmp4);
						if ($tmp4 eq $in{'t'}) {
							splice (@index,$tmp3,1);
							last;
						}
						undef $tmp4;
						$tmp3 ++;
					}
					unshift (@index,"$in{'t'}\n");
				}

				if ($SET{'FILE_UPLOAD_DO'} ne 'N' && %files) {
					umask (000);
					mkdir ("$SET{'USER_DIR'}/$in{'id'}/files",0777);
					mkdir ("$SET{'USER_DIR'}/$in{'id'}/files/$in{'t'}",0777);
					mkdir ("$SET{'USER_DIR'}/$in{'id'}/files/$in{'t'}/$no",0777);
					foreach (keys %files) {
						$tmp6 = $_;
						$tmp6 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
						open (FILE,">$SET{'USER_DIR'}/$in{'id'}/files/$in{'t'}/$no/$tmp6");
						binmode (FILE);
						print FILE $files{$_};
						close (FILE);
					}
				}

				&_write("$SET{'USER_DIR'}/$in{'id'}/index",@index);
				&_write("$SET{'USER_DIR'}/$in{'id'}/last",$log);

				if ($in{'passwd'}) {
					if (&_use("MD5")) {
						@tmp8 = ('a' .. 'z','A' .. 'Z',0 .. 9);
						&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/.passwd",&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/.passwd") . "$no:crypt:" . crypt($in{'passwd'},($tmp8[(int(rand($#tmp8)))] . $tmp8[(int(rand($#tmp8)))])) . "\n");
					} else {
						&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/.passwd",&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/.passwd") . "$no:md5:" . MD5->hexhash($in{'passwd'}) . "\n");
					}
					undef $in{'passwd'};
				}

				&_cache_flush;

				&mknmz;

				&status;
				&_unlock;

				if ($SET{'SENDMAIL_DO'} ne 'N') {

					## 
					foreach (split(/,/,lc($SET{'PTAG'}))) {
						$in{'message'} =~ s/&lt;$_.*?&gt;(.*?)&lt;\/$_&gt;/$1/gis;
					}

					foreach (split(/,/,lc($SET{'ATAG'}))) {
						$in{'message'} =~ s/&lt;$_.*?&gt;//gi;
					}

					$in{'message'} =~ s/\\\\/\\/gi;

					$in{'url'} = $ENV{'HTTP_HOST'} . $cgi . "?id=$in{'id'}&t=$in{'t'}&v=$no";
					&sendmail(&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.email$browser->{browser}","$SET{'USER_DIR'}/BF.email$browser->{browser}"),\%in);

				}

				&do($regist);
				&change($regist,\%regist);

				$print{'jump'} = "$cgi?id=$in{'id'}&t=$in{'t'}&v=$no";

				&change($regist,\%print);
				undef %print;

				$header .= &_set_cookie;
				$print .= $regist;

				$do{'nohead'} = 1;
				$do{'nocache'} = 1;

				return;

			} else {
				&form;
				undef @_;
				return;
			}
			exit(0);
		}
	}
}

sub mknmz {

	if (defined &plugin('mknmz',@_)) { return; }

	if ($SET{'MKNMZ'}) {
		my ($tmp1);
		my (@tmp2);

		$SET{'MKNMZ'} =~ s/\\/\\\\/go;
		$tmp1 = "$cgi?id=$in{'id'}&t=$in{'t'}&v=$no";
		$tmp1 =~ s/\//\\\//go;
		$tmp1 =~ s/\&/\\&/go;
		@tmp2 = ($SET{'MKNMZ'},"--allow=\"last\"","--no-encode-uri","--no-delete","--media-type=text/bforum","--replace=\"s/.*/$tmp1/\"","$SET{'USER_DIR'}/$in{'id'}/last");

		open (MKNMZ,"@tmp2 |");
		open (NMZLOG,">$SET{'USER_DIR'}/$in{'id'}/BF.mknmz.log");
		binmode (NMZLOG);
		print NMZLOG (<MKNMZ>);
		close (MKNMZ);
		close (NMZLOG);

		return;
	}
}


##
## Sendmail Ver1.01
##
sub sendmail {


	if (defined &plugin('sendmail',@_)) { return; }

	my ($tmp1);

	if ($SET{'SENDMAIL'} && open(MAIL, "| $SET{'SENDMAIL'}")) {

		binmode (MAIL);
		## Хåե󥰤ߤ
		select(MAIL);
		$| = 1;
		select(STDOUT);

		## for code
		local ($tmp2);

		$tmp1 .= "Sender: $SET{'ADDRESS'}\n";
		$tmp1 .= "MIME-Version: 1.0\n";
		$tmp1 .= "Content-type: text/plain; Charset=ISO-2022-JP\n";
		$tmp1 .= "Content-Transfer-Encoding: 7bit\n";
		$tmp1 .= "X-Mailer: BEETAS.org B.Forum {version}(Revision:{revision})\n";

		%email = %{$_[1]};
		$email{'address'} = $SET{'ADDRESS'};
		$email{'subject'} = $email{'title'};
		$email{'message'} =~ s/&lt;/</go;
		$email{'message'} =~ s/&gt;/>/go;
		$email{'message'} =~ s/&amp;/&/go;
		$email{'message'} =~ s/&quot;/"/go;
		$email{'separator'} = ("-" x ($SET{'SENDMAIL_WRAP'} || 76));
		$email{'version'} = $version;
		$email{'revision'} = $revision;

		$tmp2 = $_[0];

		$tmp2 =~ s/\n\t+([\n]+)/$1/go;

		&do($tmp1);
		&change($tmp1,\%email);

		&do($tmp2);
		&change($tmp2,\%email);

		$tmp1 =~ s/From: (.*)/"From: " . &subject($1)/ego;
		$tmp1 =~ s/Subject: (.*)/"Subject: " . &_subject($1)/ego;

		if ($SET{'SENDMAIL_WRAP'}) {
			if ($tmp2 =~ /^(.+?\n{2})(.*)$/so) {
				$tmp2 = $2;
				$tmp2 = $1 . join("\n",&_wrap($tmp2,$SET{'SENDMAIL_WRAP'}));
			}
		}

		$tmp2 =~ s/\n\n/\n$tmp1\n/o;

		&code(\$tmp2,'jis');

		$tmp2 =~ s/\n/\r\n/go;
		print MAIL $tmp2;
		close (MAIL);
	}
	undef @_;
}


##
## Subject Ver1.00
##
sub _subject {

	my ($tmp1,$tmp3,$tmp4,$tmp5);
	local ($tmp2);
	$tmp1 = join('','A' .. 'Z','a' .. 'z',0 .. 9) . "+/";
	$tmp2 = $_[0];
	&code(\$tmp2,'jis');
	$tmp2 =~ s/\x1b\x28\x42/\x1b\x28\x4a/go;
	$tmp2 = unpack("B*", $tmp2);
	for ($tmp5 = 0; $tmp3 = substr($tmp2, $tmp5, 6); $tmp5 += 6) {
		$tmp4 .= substr($tmp1, ord(pack("B*", "00" . $tmp3)), 1);
		if (length($tmp3) == 2) {
			$tmp4 .= "==";
		} elsif (length($tmp3) == 4) {
			$tmp4 .= "=";
		}
	}
	chomp ($tmp4);
	return("=?iso-2022-jp?B?$tmp4?=");
}

##
## Code Ver1.00
##
sub code {


	if (defined &plugin('code',@_)) { return; }

	if (!$init{'code'}) {
		$init{'code'} = 1;
		if ($SET{'NKF'}) {
			if (&_use($SET{'NKF'})) {
				$init{'code'} = 2;
				&error($TEXT{'ERROR_MSG_NKF'});
			}
		} elsif ($SET{'JCODE'}) {
			eval ("require \"$SET{'JCODE'}\"");
			if ($@) {
				$init{'code'} = 2;
				&error($TEXT{'ERROR_MSG_JCODE'});
			}
		}
		if ($in{'cc'}) {
			if ($in{'cc'} == "\xA5B3A1BCA5C9") {
				$code[2] = 'euc';
			} elsif ($in{'cc'} == "\x8352815B8368") {
				$code[2] = 'sjis';
			} elsif ($in{'cc'} == "\x2533213C2549") {
				$code[2] = 'jis';
#			} elsif ($in{'cc'} == "\x30B330FC30C9") {
#				$code[2] = 'utf8';
			} else {
				&error($TEXT{'ERROR_MSG_ENCODE'});
			}
		}
	}

	if ($init{'code'} == 1) {

		if (${$_[0]} =~ /\w/o) {
			if ($SET{'NKF'}) {
				${$_[0]} = NKF::nkf("--$_[1] --$code[2]-input",${$_[0]});
			} elsif ($SET{'JCODE'}) {
				jcode::convert($_[0],$_[1],$code[2],'z');
			}
		}

	}
}

sub _form {

	my ($tmp1,$tmp2,$tmp3,$tmp4);

	$tmp1 = $1;
	$tmp2 = $2;
	$tmp3 = $4;
	$tmp4 = $5;

	$tmp4 =~ s/<select (.*?)name=(["']?)(.*?)\2(.*?)>(.*?)<\/select>/&_form_select/egos;
	$tmp4 =~ s/<input (.*?)name=(["']?)(.*?)\2(.*?)>/&_form_input/egos;
	$tmp4 =~ s/<textarea (.*?)name=(["']?)(.*?)\2(.*?)>(.*?)<\/textarea>/&_form_textarea/egos;

	return "<form " . $tmp1 . "action=" . $tmp2 . $cgi . $tmp2 . $tmp3 . ">" . $tmp4 . "</form>";

}

sub _form_input {
	local ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	$tmp1 = "<input $1name=$2$3$2$4>";
	$tmp2 = $1;
	$tmp3 = $2;
	$tmp4 = $3;
	$tmp5 = $4;

	if (($tmp2 =~ /type=(["']?)text/o || $tmp5 =~ /type=(["']?)text/o) || ($tmp2 !~ /type/o && $tmp5 !~ /type/o)) {
		return &_form_text;
	} elsif ($tmp2 =~ /type=(["']?)submit/o || $tmp5 =~ /type=(["']?)submit/o) {
		return $tmp1;
	} elsif ($tmp2 =~ /type=(["']?)hidden/o || $tmp5 =~ /type=(["']?)hidden/o) {
		return &_form_hidden;
	} elsif ($tmp2 =~ /type=(["']?)checkbox/o || $tmp5 =~ /type=(["']?)checkbox/o) {
		return &_form_checkbox;
	} elsif ($tmp2 =~ /type=(["']?)radio/o || $tmp5 =~ /type=(["']?)radio/o) {
		return &_form_radio;
	} else {
		return $tmp1;
	}
}

sub _form_hidden {

	if (defined $in{$tmp4}) {
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//goi;
		$tmp1 =~ s/(\/)?>/ value="$in{$tmp4}" \/>/io;
	}

	undef @_;
	return $tmp1;
}

sub _form_checkbox {

	if (defined $in{$tmp4}) { $tmp1 =~ s/ checked(=(["']?)checked\2)?//gio; }
	foreach (split('&',$in{$tmp4})) {
		if ($tmp1 =~ / value=(["']?)$_\1/gio || $tmp1 !~ / value=(["']?).*\1/gio) {
			$tmp1 =~ s/(\/)?>/ checked="checked" \/>/io;
			last;
		}
	}

	undef @_;
	return $tmp1;
}

sub _form_radio {

	if (defined $in{$tmp4}) { $tmp1 =~ s/ checked(=(["']?)checked\2)?//gio;
		if ($tmp1 =~ / value=(["']?)$in{$tmp4}/gio) {
			$tmp1 =~ s/(\/)?>/ checked="checked" \/>/io;
		}
	}


	undef @_;
	return $tmp1;
}


sub _form_text {

	if (defined ($return = &plugin('_form_text',$tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$1))) { return $return; }

	my ($tmp6);

	if (defined $in{$tmp4}) {
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//gio;
		$tmp1 =~ s/>/ value="$in{$tmp4}">/io;
	} elsif ($in{'v'} && $tmp4 eq 'title') {
		&_analysis(\%form,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$in{'v'}"));
		$form{'title'} = $form{'full_title'};
		if ($form{'title'} =~ s/^Re\^(\d+): //o) {
			$tmp6 = "Re^" . ($1 + 1) . ": $form{'title'}";
		} elsif ($form{'title'} =~ s/^Re: //o) {
			$tmp6 = "Re^2: $form{'title'}";
		} else {
			$tmp6 = "Re: $form{'title'}";
		}
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//gio;
		$tmp1 =~ s/(\/)?>/ value="$tmp6" \/>/io;
	}

	undef @_;
	return $tmp1;
}

sub _form_textarea {
	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	$tmp1 = "<textarea $1name=$2$3$2$4>$in{$3}</textarea>";
	$tmp2 = $2;
	$tmp3 = $3;

	undef @_;
	return $tmp1;
}

sub _form_select {
	my ($tmp1,$tmp2);

	$tmp1 = "<select $1name=$2$3$2$4>$5</select>";
	$tmp2 = $3;

	if ($in{$tmp2}) {
		$tmp1 =~ s/ selected(=(["']?)selected\2)?//gio;
		$tmp1 =~ s/<(option (.*?)value=(["']?)$in{$tmp2}\3(.*?))>/<$1 selected="selected">/gio;
	}

	undef @_;
	return $tmp1;
}

##
## HTTP TIME Ver1.00
##
## HTTPǻȤλ֤֤
sub _http_time {


	my (@tmp1,@tmp2,@tmp3);

	@tmp1 = gmtime($_[0]);
	@tmp2 = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	@tmp3 = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	return sprintf("%s, %02d\ %s\ %04d %02d\:%02d\:%02d GMT",$tmp2[$tmp1[6]],$tmp1[3],$tmp3[$tmp1[4]],$tmp1[5]+1900,$tmp1[2],$tmp1[1],$tmp1[0]);

}

##
## COOKIE TIME Ver1.00
##
## COOKIEǻȤλ֤֤
sub _cookie_time {


	my (@tmp1,@tmp2,@tmp3);

	@tmp1 = gmtime($_[0]);
	@tmp2 = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
	@tmp3 = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	return sprintf("%s, %02d\-%s\-%04d %02d\:%02d\:%02d GMT",$tmp2[$tmp1[6]],$tmp1[3],$tmp3[$tmp1[4]],$tmp1[5]+1900,$tmp1[2],$tmp1[1],$tmp1[0]);

}

sub _set_cookie {
	my ($tmp1,$tmp2,$tmp3);
	$tmp1 = &_cookie_time($time + $SET{'COOKIE_TIME'});

	foreach (sort keys %in) {
		if ($_ eq 'f' || $_ eq 'id' || $_ eq 'title' || $_ eq 'message' || $_ eq 't' || $_ eq 'v' || $_ eq 'cc' || $_ eq 'confirm' || $_ eq 'plugin') { next; }
		$tmp2 = $in{$_};
		$tmp2 =~ s/([\W\%\+\;\,\=\&\_\:])/'%' . unpack("H2",$1)/ego;
		$tmp3 .= "$_:$tmp2,";
	}
	undef @_;
	return "Set-Cookie: B.Forum:$in{'id'}=$tmp3; expires=$tmp1\n";
}

sub _get_cookie {
	local ($tmp1);
	my ($tmp2);
	local (@tmp3);
	foreach $tmp1 (split(/;\s*/,$ENV{'HTTP_COOKIE'})) {
		if ((split(/=/,$tmp1))[0] eq "B.Forum:$in{'id'}") {
			&code(\$tmp1,'euc');
			foreach $tmp2 (split(/,\s*/,(split(/=/,$tmp1))[1])) {
				@tmp3 = split(/:/,$tmp2);
				$tmp3[1] =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;
				$in{$tmp3[0]} = $tmp3[1];
			}
			last;
		}
	}
}

sub _lock {
	my ($tmp1,$tmp2);
	if (open (LOCK,"$SET{'USER_DIR'}/$in{'id'}/lock")) {
		binmode (LOCK);
		$tmp1 = <LOCK>;
		close (LOCK);
		chomp ($tmp1);
		$tmp2 = 0;
		foreach (1 .. $SET{'LOCK_RETRY'}) {
			if (($time - $tmp1) > $SET{'LOCK_FREE'}) {
				$tmp2 = 1;
				last;
			} else {
				sleep (1);
			}
		}
	} else {
		$tmp2 = 1;
	}
	if ($tmp2) {
		open (LOCK,">$SET{'USER_DIR'}/$in{'id'}/lock");
		binmode (LOCK);
		print LOCK $time;
		close(LOCK);
		return 1;
	} else {
		$notice = &_open(1,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser->{browser}","$SET{'USER_DIR'}/BF.error$browser->{browser}") || "<b>ߤäƤޤ</b>\n";
		return;
	}
}

sub _unlock {
	unlink ("$SET{'USER_DIR'}/$in{'id'}/lock");
}

sub _analysis {

	if (defined ($return = &plugin('_analysis',@_))) { return $return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);

	($tmp1,$tmp2) = @_;
	($tmp2,$tmp3) = split(/\n\n/,$tmp2,2);
	foreach (split(/\n/,$tmp2)) {
		if ($_ =~ /^\s*(.+?):\s+(.*?)\s*$/o) {
			$tmp4 = lc $1;
			$$tmp1{$tmp4} = $2;
		}
	}

	if ($$tmp1{'type'} ne 'text/html') {
		$tmp6 = &_br($tmp3);
	} else {
		$tmp6 = $tmp3;
	}

	if (!$$tmp1{'title'}) { $$tmp1{'title'} = "(̵)"; }

	$$tmp1{'full_title'} = $$tmp1{'title'};
	if ($SET{'TITLE_LENGTH'}) {
		$$tmp1{'title'} = &_cut($$tmp1{'full_title'},$SET{'TITLE_LENGTH'},'...');
	}

	$$tmp1{'message'} = $tmp6 || "";
	$$tmp1{'message'} =~ s/\\/\\\\/g;

	foreach (keys %$tmp1) {
		$$tmp1{$_} =~ s/{/\\{/go;
	}


	undef @_;
	return ($$tmp1{'no'},$$tmp1{'title'},$$tmp1{'author'},$$tmp1{'email'},$$tmp1{'date'},$$tmp1{'message'});
}

##
## BR Ver1.01
##
## $aβԤ򥿥ˤ
## Ǥ̵뤹
## $A = &_br($a);
sub _br {

	my ($tmp1,$tmp2);

	foreach (split(/\n/,$_[0])) {
		if ($_ =~ /<.*[^\/]>/o) { $tmp1++; }
		if ($_ =~ /<\/.*>/o) { $tmp1--; }
		if ($_ !~ /^[\s\t]*<.*>[\s\t]*$/ && !$tmp1) { $_ .= "\n<br />"; }
		$tmp2 .= $_ . "\n";
	}

	return $_[0] = $tmp2;

}

##
## Cut Ver1.02
##
## $a$bڤ$cĤ
## $A = &_cut($a,$b[,$c]);
sub _cut {


	my ($tmp1);

	$tmp1 = $_[0];
	if (length $tmp1 > $_[1]) {

#		## ʸǶڤ
#   ## ڤɬפ
#		if ($tmp1 =~ /(.{1,$_[1]}).+/o) {
#			$tmp1 = $1;
#		}
		$tmp1 = substr($tmp1,0,$_[1]);

		## EUCθüΥߤ
		if (($tmp1 =~ /([\xa1-\xfe]+)$/o && length($1) % 2) || $tmp1 =~ /\x8f$/o) { $tmp1 = substr($tmp1,0,(length($tmp1) - 1)); }

		return $tmp1 . $_[2];
	} else {
		return $_[0];
	}

}

##
## Wrap Ver1.00
##
sub _wrap {

	my ($tmp1,$tmp2);
	my (@tmp3);

	$_[1]++;
	foreach (split("\n",$_[0])) {
		$tmp1 = $_;
		while (length $tmp1 > $_[1]) {
			$tmp2 = &_cut($tmp1,$_[1]);
			push (@tmp3,$tmp2);
			substr($tmp1,0,length($tmp2),"");
		}
		push (@tmp3,$tmp1);
	}

	return @tmp3;

}

##
## CrossSiteScripting Ver.1.00
##
sub _xss {


	$_[0] =~ s/(<a.*?href=(["']?))(.*?)(\2.*?>)/$1 . &__xss($3) . $4/ego;

}

sub __xss {

	my ($tmp1);

	$tmp1 = $_[0];
	$tmp1 =~ s/&([^(amp;)])/&amp;$1/go;
	$tmp1 =~ s/<([^(lt;)])/&lt;$1/go;
	$tmp1 =~ s/>([^(gt;)])/&gt;$1/go;
	$tmp1 =~ s/"([^(quot;)])/&quot;$1/go;

	return $tmp1;

}

sub _xhtmlcheck {

	$_[0] =~ s/<(\w+)([^>]*)>/&__xhtmlcheck/ego;
	return $_[0];

}

sub __xhtmlcheck {

	my ($tmp1,$tmp2);
	my (@tmp3);

	$tmp1 = $1;
	$tmp2 = $2;

	## ex.
	## checked -> checked="checked"
	$tmp2 =~ s/(\s)([^=\s]+)(\s)/$1$2="$2"$3/go;

	## ex.
	## width=100 -> width="100"
	$tmp2 =~ s/(\s)(\w+=)([\w\d\.\~\-\/\?\&\+\=\:\@\%\;\#\%]+)/$1$2"$3"/go;

	## ex.
	## <IMG SRC= -> <img src=
	$tmp2 =~ s/(\W)(\w+)(=?.*\W)/$1 . lc($2) . $3/ego;

	$tmp1 .= $tmp2;

#	@tmp3 = ('area','base','basefont','col','br','hr','img','input');
	@tmp3 = split(',',lc($SET{'ATAG'}));

	foreach (@tmp3) {
		if ($tmp1 =~ /^$_/i) {
			if ($tmp1 =~ /\/$/o) {
				return "<$tmp1>";
			} else {
				return "<$tmp1 />";
			}
		}
	}
	return "<$tmp1>";

}

sub tag {

	foreach (split(/,/,lc($SET{'PTAG'}))) {
		$_[0] =~ s/&lt;$_(.*?)&gt;(.*?)&lt;\/$_&gt;/&_tag('p')/egis;
	}

	foreach (split(/,/,lc($SET{'ATAG'}))) {
		$_[0] =~ s/&lt;$_(.*?)&gt;/&_tag('a')/egi;
	}

}

sub _tag {
	my ($tmp1,$tmp2);
	$tmp1 = $1;
	$tmp2 = $2;

	$tmp1 =~ s/&amp;/&/go;
	$tmp1 =~ s/&lt;/</go;
	$tmp1 =~ s/&gt;/>/go;
	$tmp1 =~ s/&quot;/"/go;

	$tmp1 =~ s/ href=(["']?)(.*)\1/ $browser->{href}=$1$2$1 target="_blank"/go;
	$tmp1 =~ s/ on\w+=(["']?)(.*)\1//gio;
	if ($_[0] eq 'p') {
		undef @_;
		$tmp2 =~ s/\n<br>\n/\n/go;
		return "<$_$tmp1>$tmp2<\/$_>";
	}
	if ($_[0] eq 'a') {
		undef @_;
		if (!$tmp1 =~ /\/$/o) { $tmp1 .= " /"; }
		return "<$_$tmp1>";
	}
}

sub _hyperlink {
	$_[0] =~ s/<a([^>]+)$browser->{href}=(["']?)$_[1]\2>(.+)<\/a>/<a$1$browser->{href}=$2$_[2]$2>$3<\/a>/gio;
}

sub _link {

	##
	## Link Ver1.01
	##

	return ('<a ' . $browser->{href} . '="' . $cgi . '?' . $_[0] . '">' . $_[1] . '</a>');
}

##
## Autolink Ver1.01
##
sub _autolink {


	$_[0] =~ s/([^=^\"^'^>]|^)(http\:\/\/[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%]+)\.(gif|jpg|png)/$1<a $browser->{href}=\"$2\.$3\" target="_blank"><img src=\"$2\.$3\" border="0" \/><\/a>/go;
	$_[0] =~ s/([^=^\"^'^>]|^)(http\:\/\/[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%]+)/$1<a $browser->{href}=\"$2\" target="_blank">$2<\/a>/go;
	$_[0] =~ s/([^=^\"^'^>]|^)([\w-_]+)\@([\w\.-]+)/$1<a $browser->{href}=\"mailto:$2\@$3\">$2\@$3<\/a>/go;
	$_[0] =~ s/([^=^\"^'^>]|^)&gt;&gt;(\d+)/$1<a $browser->{href}=\"$cgi?id=$in{'id'}&t=$in{'t'}&v=$2\">&gt;&gt;$2<\/a>/go;
}

sub _transpose {
	$print{'new_thread:url'} = "$cgi?id=$in{'id'}&f=f";
	$print{'help:url'} = "$cgi?Help&id=$in{'id'}";
	$print{'res:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&v=$in{'v'}&f=f";
	$print{'post:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&f=f";
	$print{'old:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&v=1";
	$print{'new:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&v=$view{'number'}";
	$print{'list:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&v=list&s=$in{'s'}";
	$print{'tree:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&v=tree&s=$in{'s'}";
	$print{'top:url'} = "$cgi?$in{'id'}";

	$print{'new_thread'} = &_link("id=$in{'id'}&f=f",$SET{'DISP_NEW_THREAD'});
	$print{'help'} = &_link("Help&id=$in{'id'}",$SET{'DISP_HELP'});
	$print{'res'} = &_link("id=$in{'id'}&t=$in{'t'}&v=$in{'v'}&f=f",$SET{'DISP_RES'});
	$print{'post'} = &_link("id=$in{'id'}&t=$in{'t'}&f=f",$SET{'DISP_POST'});
	$print{'first'} = &_link("id=$in{'id'}&t=$in{'t'}&v=1",$SET{'DISP_FIRST'});
	$print{'last'} = &_link("id=$in{'id'}&t=$in{'t'}&v=$view{'number'}",$SET{'DISP_LAST'});
	$print{'list'} = &_link("id=$in{'id'}&t=$in{'t'}&v=list&s=$in{'s'}",$SET{'DISP_LIST'});
	$print{'tree'} = &_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=$in{'s'}",$SET{'DISP_TREE'});
	$print{'top'} = &_link("$in{'id'}",$SET{'DISP_TOP'});

	&change($_[0],\%print);
	undef %print;

}

sub status {

	if (defined &plugin('status',@_)) { return; }

	my (@tmp1);

	if (-s "$SET{'USER_DIR'}/$in{'id'}/index") {

		&_analysis(\%status,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/last"));

		$status{'thread'} = 0;
		$status{'log'} = 0;
		$status{'date'} ||= ($time - int((-M "$SET{'USER_DIR'}/$in{'id'}/index") * 86400));
		foreach (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/index")) {

			chomp($_);
			if (!-f "$SET{'USER_DIR'}/$in{'id'}/$_/1" && !-f "$SET{'USER_DIR'}/$in{'id'}/$_.0.bfa") { next; }

			$status{'thread'} ++;
			$status{'log'} += &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$_/list") + 1;
		}

		$tmp1[0] = "Thread: $status{'thread'}\n";
		$tmp1[1] = "Log: $status{'log'}\n";
		$tmp1[2] = "Date: $status{'date'}\n";

		&_write("$SET{'USER_DIR'}/$in{'id'}/status",@tmp1);

	}

}

sub plugin {
	my ($tmp1,$tmp2,$tmp3,$tmp4);
	$tmp1 = shift @_;

	if ($SET{'PLUGIN_DIR'}) {
		$plugin = &_open(undef,"$SET{'PLUGIN_DIR'}/$tmp1.pl");
		if ($plugin) {

			if ($debug) { no strict; }

			open (NULL,undef);
			$tmp2 = select (NULL);

			if (eval($plugin) && eval "${tmp1}::status();" && ((! eval "${tmp1}::require_max();" || (split(/\./,$revision))[-1] <= eval "${tmp1}::require_max();") && (! eval "${tmp1}::require_min();" || (split(/\./,$revision))[-1] >= eval "${tmp1}::require_min();"))) {
				$tmp3 = eval("${tmp1}::main(\$head,\$foot,\\\%in,\@_);");
				if ($@) {
					$WARNING{'Plugin: ' . $tmp1} = $@;
					undef $tmp4;
				} elsif (defined $tmp3) {
					$plugin{($SET{'PLUGIN_DIR'} . "/" . $tmp1 . ".pl")} = eval("${tmp1}::version();");
					$tmp4 = $tmp3;
				} else {
					$WARNING{'Plugin: ' . $tmp1} = "return undef";
					undef $tmp4;
				}
			} else {
				$WARNING{'Plugin: ' . $tmp1} = "version missmatch or status failed";
				undef $tmp4;
			}
			select ($tmp2);
			close (NULL);
			$print .= $tmp4;

			if ($debug) { use strict; }

			return $tmp4;
		} else {
			return;
		}
	} else {
		return;
	}
}

sub limit {

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);

	undef $tmp1;

	map { $_ =~ tr/0-9//cd; } ($SET{'LIMIT_THREAD'},$SET{'LIMIT_THREAD_ITEM'},$SET{'LIMIT_CAPACITY'},$SET{'LIMIT_ITEM'});

	if (defined $SET{'LIMIT_THREAD'} || defined $SET{'LIMIT_THREAD_ITEM'} || defined $SET{'LIMIT_CAPACITY'} || defined $SET{'LIMIT_ITEM'}) {
		if (!$tmp1 && defined $SET{'LIMIT_THREAD'} && !$in{'t'}) {

			&_analysis(\%status,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/status"));
			if (!($status{'thread'} && $status{'log'} && $status{'date'})  && -f "$SET{'USER_DIR'}/$in{'id'}/index") { &status; }
			$tmp2 = $status{'thread'};

			if ($SET{'LIMIT_THREAD'} <= $tmp2) { $tmp1 = 1; }

		}
		if (!$tmp1 && defined $SET{'LIMIT_THREAD_ITEM'} && $in{'t'} && $SET{'LIMIT_THREAD_ITEM'} <= (&_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list") + 1)) {
			$tmp1 = 1;
		}
		if (!$tmp1 && defined $SET{'LIMIT_CAPACITY'} || defined $SET{'LIMIT_ITEM'}) {

			undef $tmp3;
			undef $tmp4;

			foreach $tmp5 (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/index")) {
				chomp($tmp5);
				if (!-f "$SET{'USER_DIR'}/$in{'id'}/$tmp5/1" && !-f "$SET{'USER_DIR'}/$in{'id'}/$tmp5.bfa")  {
					next;
				} elsif (-f "$SET{'USER_DIR'}/$in{'id'}/$tmp5.bfa") {
					$tmp3 += (-s "$SET{'USER_DIR'}/$in{'id'}/$tmp5.bfa");
					$tmp4 += (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/$tmp5/list") || 1);
				} else {

					foreach $tmp6 (&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$tmp5/list") || 1) {
						if ($SET{'SECTORSIZE'}) {
							$tmp3 += ((int((-s "$SET{'USER_DIR'}/$in{'id'}/$tmp5/$tmp6")/$SET{'SECTORSIZE'})) + 1) * $SET{'SECTORSIZE'};
						} else {
							$tmp3 += (-s "$SET{'USER_DIR'}/$in{'id'}/$tmp5/$tmp6");
						}
					}
					$tmp4 += (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/$tmp5/list") || 1);

				}
			}
			if (defined $SET{'LIMIT_CAPACITY'} && $SET{'LIMIT_CAPACITY'} <= $tmp3) {
				$tmp1 = 1;
			} elsif (defined $SET{'LIMIT_ITEM'} && $SET{'LIMIT_ITEM'} <= $tmp4) {
				$tmp1 = 1;
			}

		}

	}

	return $tmp1;

}

##
## TIME Ver1.00
##
sub _time {

	my ($tmp1);
	my (@tmp2);

	$ENV{'TZ'} = $SET{'TIME_ZONE'} || "JST-9";
	@tmp2 = localtime($_[0]);
	$tmp1 = $_[1] || $SET{'TIME_FORMAT'};
	$tmp1 =~ s/%ss/sprintf("%02d",$tmp2[0])/ego;
	$tmp1 =~ s/%s/$tmp2[0]/go;
	$tmp1 =~ s/%mm/sprintf("%02d",$tmp2[1])/ego;
	$tmp1 =~ s/%m/$tmp2[1]/go;
	$tmp1 =~ s/%HH/{ if (($tmp2[2] - 12) > 0) { sprintf("%02d",($tmp2[2] - 12)); } else { sprintf("%02d",$tmp2[2]); } }/ego;
	$tmp1 =~ s/%H/{ if (($tmp2[2] - 12) > 0) { ($tmp2[2] - 12); } else { $tmp2[2]; } }/ego;
	$tmp1 =~ s/%hh/sprintf("%02d",$tmp2[2])/ego;
	$tmp1 =~ s/%h/$tmp2[2]/go;
	$tmp1 =~ s/%AP/(split(',',$SET{'AP_FORMAT'}))[(($tmp2[2] - 12) > 0)]/ego;
	$tmp1 =~ s/%DD/sprintf("%02d",$tmp2[3])/ego;
	$tmp1 =~ s/%D/$tmp2[3]/go;
	$tmp1 =~ s/%MF/(split(',',$SET{'MONTH_FORMAT'}))[($tmp2[4])]/ego;
	$tmp1 =~ s/%MM/sprintf("%02d",($tmp2[4] + 1))/ego;
	$tmp1 =~ s/%M/{$tmp2[4] + 1}/ego;
	$tmp1 =~ s/%YYYY/sprintf("%04d",($tmp2[5] + 1900))/ego;
	$tmp1 =~ s/%YY/sprintf("%02d",substr($tmp2[5],-1,2))/ego;
	$tmp1 =~ s/%w/(split(',',$SET{'WEEK_FORMAT'}))[($tmp2[6])]/ego;

	if (defined wantarray) {
		return $tmp1;
	} else {
		$_[0] = $tmp1;
		return $tmp1;
	}
}

sub _default {
	$thread ||= 0;
	$log ||= 0;
	$date ||= &_time(0);
	$id ||= $in{'id'};
	undef @_;
}

sub _replace {
	${$_[0]} =~ s/<\!-- $_[1] --> (.+?) <\!-- $_[1] -->/<\!-- $_[1] --> $_[2] <\!-- $_[1] -->/gs;
	undef @_;
}


sub _open {

	my ($tmp1,$tmp2,$tmp3);
	my (@tmp4,@tmp5,@tmp6);

	($tmp1,@tmp4) = @_;
	undef @_;

	foreach (@tmp4) {
		$tmp2 = $_;
		$tmp2 =~ s/\/+/\//go;
		$tmp2 =~ s/;.*$//go;
#		&_path($tmp2);
		if (defined $cache{'file'}{$tmp2}) {
			@tmp5 = split(/\n/,$cache{'file'}{$tmp2});
			map { $_ .= "\n"; } @tmp5;
			last;
		} else {
			@tmp5 = ();
			if ($tmp2 !~ /^>/) { @tmp5 = &_archive(0,$tmp2); }
			if ($tmp2 =~ /^>/o || -r $tmp2) {
				open (FILE,$tmp2);
				binmode (FILE);
				@tmp5 = <FILE>;
				close (FILE);
			}
			if (@tmp5) {
				last;
			} else {
				next;
			}
		}
	}

	## Do command that in file.
	foreach (@tmp5) {
		if ($_ =~/^#(.+)\s+(.+)\s+$/o) {
			if ($1 eq 'include') {
				## include
				if ($2 ne (split('/',$tmp2))[-1]) {
					@tmp6 = split('/',$tmp2);
					$_ = &_open(undef,join('/',splice(@tmp6,0,-1)) . "/$2");
				}
			}
		}
	}

	if ($tmp1 eq 'file') {
		## First argument is 'file'.
		return @tmp5;
	} elsif ($tmp1 eq 'line') {
		## First argument is 'line'.
		if (!join('',@tmp5)) {
			## File is 0byte.
			return 0;
		} else {
			return $tmp3 = @tmp5;
		}
	} else {
		if (defined $tmp1) {
			## First argument is number.

			## File cache.
			$cache{'file'}{$tmp2} = join('',@tmp5);
			return $tmp5[$tmp1];
		} else {

			## File cache.
			$cache{'file'}{$tmp2} = join('',@tmp5);
			return join('',@tmp5);
		}
	}
}

##
## Path Ver1.01
##
sub _path {

	if (!$init{'cwd'}) {
		use Cwd;
		$init{'cwd'} = 1;
	}

	## Macintoshк
	$_[0] =~ tr/\\:/\//s;

	if ($_[0] !~ /^(\/|~|\w\/|:)/) {
		$_[0] = Cwd::cwd() . "/" . $_[0];
		$_[0] =~ s/\/\.\//\//go;
		while ($_[0] =~ /[^\/]+\/\.\.\//o) {
			$_[0] =~ s/[^\/]+\/\.\.\///go;
		}
	}

	## Windowsк
	$_[0] =~ s/^(\w)\/\//$1:\//;

	return $_[0];

}

sub _flush {
	undef $cache{'file'}{$_[0]};
}

sub _cache_flush {

	my ($tmp1);
	my (@tmp2);

	opendir (CACHE,"$SET{'USER_DIR'}/.cache");
	@tmp2 = readdir(CACHE);
	closedir (CACHE);
	foreach (@tmp2) {
		if ($_ eq '.' || $_ eq '..') { next; }
		if ($in{'id'}) {
			$tmp1 = $in{'id'};
			$tmp1 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
			if ($_ =~ /^(id%3d)?$tmp1&?/i) { unlink("$SET{'USER_DIR'}/.cache/$_"); }
		} else {
			unlink("$SET{'USER_DIR'}/.cache/$_");
		}
	}
}

sub _write {

	my ($tmp1,$tmp2,$tmp3);
	my (@tmp4);
	$tmp1 = shift(@_);

	if ($tmp1 =~ /$SET{'USER_DIR'}\/$in{'id'}\/$in{'t'}\/.+$/o && (!-d "$SET{'USER_DIR'}/$in{'id'}/$in{'t'}" || $tmp1 =~ /BF..+$/o)) {
		($tmp2) = &_archive(1,$tmp1,(join('',@_)));
	}
	if (!$tmp2 || !(!-d "$SET{'USER_DIR'}/$in{'id'}/$in{'t'}" || $tmp1 =~ /BF..+$/o)) {
		@tmp4 = split('/',$tmp1);
		pop(@tmp4);
		$tmp3 = join('/',@tmp4);
		if (!-d $tmp3) {
			umask (000);
			mkdir ($tmp3,0777) || &error;
		}
		open (FILE,">$tmp1.tmp") || &error;
		binmode (FILE);
		print FILE @_;
		close (FILE);
		if (-f $tmp1) { unlink ($tmp1) || &error; }
		rename ("$tmp1.tmp",$tmp1) || &error;
	}

	&_flush($tmp1);

	undef @_;
	return;

}

sub _archive {

	my ($tmp1,$tmp2,$tmp3,$tmp4);
	my (@tmp5);

	if ($_[1] =~ /^(.+)\/(index|last|status|.bforumrc|.bforumrc.cache|.+\.bfa)$/o) {
		return;
	} elsif ($_[1] =~ /^(.+)\/(BF\..+)$/o) {
		$tmp2 = "$1/BF.bfa";
		$tmp3 = $2;
	} elsif ($_[1] =~ /^(.+)\/(.+)$/o) {
		$tmp1 = $1;
		$tmp3 = $2;
		if ($2 =~ /(list)/o) {
			$tmp2 = "$tmp1.0.bfa";
		} elsif ($2 =~ /\D/) {
			$tmp2 = "$tmp1.bfa";
		} else {
			$tmp2 = "$tmp1." . int($2 / 10) . ".bfa";
		}
	} else {
		return;
	}

	if (!$init{'archive'} && (($_[0] && $SET{'ARCHIVE_DO'} ne 'N') || (!$_[0] && -f $tmp2))) {
#		if (&_use($SET{'ARCHIVE'})) { return; }
		if (&_use("Archive::Tar")) { return; }
		$init{'archive'} = 1;
	}

	if ($Archive::Tar::VERSION > 0.072) { return; }

	if (!$init{'archive'}) { return; }

	$tmp4 = Archive::Tar->new();

	if (exists $cache->{'archive'}->{$tmp2}) {
		$tmp4 = $cache->{'archive'}->{$tmp2};
	} elsif (-f $tmp2) {
		$tmp4->read($tmp2,1);
		$cache->{'archive'}->{$tmp2} = $tmp4;
	}

	if ($_[0] && $SET{'ARCHIVE_DO'} ne 'N') {
		$tmp4->remove($tmp3);
		$tmp4->add_data($tmp3,$_[2]);
		if ($SET{'COMPRESS_DO'} ne 'N') {
			&_compress($tmp2,$tmp4->write());
		} else {
			$tmp4->write($tmp2);
			$tmp4 = Archive::Tar->new();
			$tmp4->read($tmp2,1);
		}
		@tmp5 = ($tmp2);
	} elsif (-f $tmp2) {
		@tmp5 = split(/\n/,$tmp4->get_content($tmp3));
		map { $_ .= "\n"; } @tmp5;
	} else {
		return;
	}

	undef $tmp4;
	return @tmp5;

}

sub _compress {

	my ($tmp1,$tmp2,$tmp3);

	if ($SET{'COMPRESS_DO'} ne 'N') {
		if (!$init{'compress'}) {
#			if (&_use($SET{'COMPRESS'})) { return; }
			if (&_use("Compress::Zlib")) { return; }
			$init{'compress'} = 1;
		}
		if ($SET{'COMPRESS_LEVEL'}) {
			$tmp1 = Compress::Zlib::deflateInit(-Level => $SET{'COMPRESS_LEVEL'});
		} else {
			$tmp1 = Compress::Zlib::deflateInit();
		}
		if (defined $tmp1) {
			if ($_[1]) {
				$tmp2 = $_[1];
			} else {
				$tmp2 = &_open(undef,$_[0]);
			}
			if (defined $tmp1->deflate($tmp2)) {
				$tmp3 = Compress::Zlib::gzopen($_[0],"wb");
				$tmp3->gzwrite($tmp2);
				$tmp3->gzclose;
				return $tmp2;
			}
		}
	} else {

		return;

	}

}


##
## Do Ver1.01
##
sub do {


	$_[0] =~ s/(\\*)<%(.+?)(\\*)%>/&_do/egios;

}

sub _do {

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	if ($debug) { no strict; }

	if (length($1) % 2 || length($3) % 2) {
		$tmp1 = $1 . '<%' . $2 . $3 . '%>';
	} else {
		$tmp2 = $1;
		$tmp3 = $2;
		$tmp4 = $3;
		$tmp3 =~ s/(\W)print(\W)/$1\$tmp5 .=$2/go;
		eval ($tmp3);
		$tmp1 = $tmp2 . $tmp5 . $@ . $tmp4;
	}

	if ($debug) { use strict; }

	undef @_;
	return $tmp1;
}

##
## Change Ver1.01
##
sub change {


	$_[0] =~ s/(\\*)(\w*){(.+?)}/&_change($_[1])/ego;

}

sub _change {

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);

	$tmp2 = $1;
	$tmp3 = $2;
	$tmp4 = $3;

	if (length($tmp2) % 2) {
		$tmp1 = $tmp2 . $tmp3 . '{' . $tmp4 . '}';
	} else {

		if ($tmp4 =~ /^(.+?)\((.+?)\)$/o) {
			$tmp4 = $1;
			$tmp5 = $2;
		}

		if ($_[0]) {
			if (${$_[0]}{$tmp4}) {
				$tmp6 = $tmp3 . ${$_[0]}{$tmp4};
			} elsif (defined ${$_[0]}{$tmp4}) {
				$tmp6 = $tmp3;
			} else {
				$tmp6 = $tmp3 . '{' . $tmp4 . '}';
			}
		} else {
			if (${$tmp4}) {
				$tmp6 = $tmp3 . ${$tmp4};
			} elsif (defined ${$tmp3}{$tmp4}) {
				$tmp6 = ${$tmp3}{$tmp4};
			} elsif (defined *tmp4) {
				$tmp6 = $tmp3;
			} else {
				$tmp6 = $tmp3 . '{' . $tmp4 . '}';
			}
		}

		if ($tmp5) {

			$tmp6 =~ s/<.+?>//go;
			$tmp6 =~ s/\&lt;.+?\&gt;//go;
			$tmp6 =~ s/\n//gio;
			$tmp1 = $tmp2 . &_cut($tmp6,$tmp5,'...');

		} else {

			$tmp1 = $tmp2 . $tmp6;

		}

	}

	undef @_;
	return $tmp1;
}

sub _indexcheck {

	my ($tmp1,$tmp2);

	$tmp2 = 0;
	foreach $tmp1 (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/index")) {

		chomp($tmp1);
		if (!-d "$SET{'USER_DIR'}/$in{'id'}/$tmp1" && !-f "$SET{'USER_DIR'}/$in{'id'}/$in{'t'}.0.bfa") { next; }

		if ($tmp1 eq $in{'t'}) {
			$tmp2 = 1;
			last;
		}

	}

	return $tmp2;

}

sub _listcheck {

	my ($tmp1,$tmp2);

	if ($_[0] eq '1') { return 1; }

	undef $tmp2;
	foreach $tmp1 (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")) {

		chomp ($tmp1);
		if ($tmp1 =~ /^#/o) { next; }

		if ((split(/<0>/,$tmp1))[0] eq $_[0]) {
			$tmp2 = 1;
			last;
		}

	}

	undef @_;
	return $tmp2;

}

sub _reflexive {

	my (@tmp1,@tmp2);

	opendir (DIR,$_[0]);
	@tmp1 = readdir(DIR);
	closedir (DIR);
	foreach (@tmp1) {
		if ($_ =~ /\.{1,2}/o) { next; }
		if (-s "$_[0]/$_/index") {
			push (@tmp2,$_[0]);
		} elsif (-d "$_[0]/$_") {
			&_reflexive("$_[0]/$_");
		}
	}

	return @tmp2;

}

##
## Logging Ver1.00
##
sub _logging {


	# Just a moment please!!

}

##
## Use Ver1.01
##
sub _use {

	if (!defined $init{$_[0]}) {
		eval ("use $_[0]");
		$init{$_[0]} = $@;
	}
	return $init{$_[0]};

}

sub browser {

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7,$tmp8);


	$tmp1 = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.browser","$SET{'USER_DIR'}/BF.browser");

	$tmp1 =~ s/[^\\]#.*\n//go;

	foreach $tmp2 ($tmp1 =~ /\n*([^\n]*?:[^:]*)\n/gos) {
		$tmp2 =~ s/\n//go;
		$tmp2 =~ /(.*):(.*)/o;
		$tmp3 = $1;
		$tmp4 = $2;
		$tmp4 =~ s/[\n\s]//go;
		foreach $tmp5 ($tmp4 =~ /(.*?=.*?);/go) {
			$tmp5 =~ /(.*?)=(.*)/o;
			$tmp6 = $1;
			$tmp7 = $2;
			$browser->{$tmp3}->{$tmp6} = $tmp7;
		}
	}

	$tmp8 = (split('/',$ENV{'HTTP_USER_AGENT'}))[0];

	$browser->{content} = $browser->{$tmp8}->{content} || $browser->{Default}->{content};
	$browser->{href} = $browser->{$tmp8}->{href} || $browser->{Default}->{href};
	@code = split(',',($browser->{$tmp8}->{code} || $browser->{Default}->{code}));
	$browser->{browser} = $browser->{$tmp8}->{browser} || $browser->{Default}->{browser};

}

##
## Check Ver1.01
##
sub check {

	my ($tmp1,$tmp2);

	&_path($SET{'USER_DIR'});

	## ADDRESS
	$check->{'Address'}->{'status'} = "OK";
	$check->{'Address'}->{'value'} = $SET{'ADDRESS'};
	if ($SET{'ADDRESS'} !~ /^.+\@.+\..+$/) {
		$check->{'Address'}->{'status'} = "NG";
	}

	## USER_DIR
	$check->{'User directory'}->{'status'} = "OK";
	$check->{'User directory'}->{'value'} = "$SET{'USER_DIR'}/";
	if (!-d $SET{'USER_DIR'}) {
		$check->{'User directory'}->{'status'} = "NG";
		$check->{'User directory'}->{'value'} = "Not found:<b>$SET{'USER_DIR'}/</b>";
	} elsif (!-r $SET{'USER_DIR'} || !-w $SET{'USER_DIR'} || !-x $SET{'USER_DIR'}) {
		$check->{'User directory'}->{'status'} = "NG";
		$check->{'User durectory'}->{'value'} = "Permission denied:<b>$SET{'USER_DIR'}/</b>";
	}

	## 
	if ($in{'id'} ne 'Check') {

		## ȥǥ쥯ȥ
		$check->{'Data directory'}->{'status'} = "OK";
		$check->{'Data directory'}->{'value'} = "$SET{'USER_DIR'}/$in{'id'}/";
		if (!-d "$SET{'USER_DIR'}/$in{'id'}") {
			$check->{'Data directory'}->{'status'} = "NG";
			$check->{'Data directory'}->{'value'} = "Not found:<b>$SET{'USER_DIR'}/$in{'id'}</b>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}" || !-w "$SET{'USER_DIR'}/$in{'id'}" || !-x "$SET{'USER_DIR'}/$in{'id'}") {
			$check->{'Data directory'}->{'status'} = "NG";
			$check->{'Data directory'}->{'value'} = "Permission denied:<b>$SET{'USER_DIR'}/$in{'id'}</b>";
		}

		## indexեγǧ
		$check->{'Index file'}->{'status'} = "OK";
		$check->{'Index file'}->{'value'} = "$SET{'USER_DIR'}/$in{'id'}/index";
		if (!-d "$SET{'USER_DIR'}/$in{'id'}") {
			$check->{'Index file'}->{'status'} = "NG";
			$check->{'Index file'}->{'value'} = "Not found:<b>$SET{'USER_DIR'}/$in{'id'}/index</b>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}/index" || !-w "$SET{'USER_DIR'}/$in{'id'}/index") {
			$check->{'Index file'}->{'status'} = "NG";
			$check->{'Index file'}->{'value'} = "Permission denied:<b>$SET{'USER_DIR'}/$in{'id'}/index</b>";
		}

	}

	## Sendmail
	$check->{'Sendmail'}->{'status'} = "OK";
	($tmp1,undef) = split(/\s/,$SET{'SENDMAIL'});
	$check->{'Sendmail'}->{'value'} = $SET{'SENDMAIL'};
	if (!-e $tmp1) {
		$check->{'Sendmail'}->{'status'} = "NG";
		$check->{'Sendmail'}->{'value'} = "Not found:<b>$tmp1</b>";
	} elsif (!-x $tmp1 && !-r $tmp1) {
		$check->{'Sendmail'}->{'status'} = "NG";
		$check->{'Sendmail'}->{'value'} = "Permission denied:<b>$tmp1</b>";
	}

	foreach (
		{item => "Do sendmail",set => "SENDMAIL_DO"},
		{item => "Do portal",set => "PORTAL_DO"},
		{item => "Do check",set => "CHECK_DO"},
		{item => "Do archive",set => "ARCHIVE_DO"},
		{item => "Do compress",set => "COMPRESS_DO"},
		{item => "Do cache",set => "CACHE_DO"},
		{item => "Do fileupload",set => "FILE_UPLOAD_DO"},
	) {
		$check->{$_->{'item'}}->{'status'} = "Yes";
		$check->{$_->{'item'}}->{'value'} = "Value OK";
		if ($SET{$_->{'set'}} eq 'N') {
			$check->{$_->{'item'}}->{'status'} = "No";
		} elsif ($SET{$_->{'set'}} ne 'Y') {
			$check->{$_->{'item'}}->{'value'} = "Illegal value:<b>$SET{$$_{'set'}}</b>";
		}
	}

	$check->{'User name'}->{'status'} = "OK";
	$check->{'User name'}->{'value'} = getlogin;

	$check->{'Default Language'}->{'status'} = "OK";
	$check->{'Default Language'}->{'value'} = $SET{'LANGUAGE'};

	## BF.*եγǧ
	foreach ("BF.about","BF.browser","BF.confirm","BF.delete","BF.email","BF.email.error","BF.error","BF.foot","BF.form","BF.help","BF.head","BF.index","BF.index.foot","BF.index.head","BF.list","BF.list.foot","BF.list.head","BF.notice","BF.portal","BF.regist","BF.thread","BF.thread.foot","BF.thread.head","BF.tree","BF.tree.foot","BF.tree.head","BF.view") {
		$check->{$_}->{'status'} = "OK";
		if (!-f "$SET{'USER_DIR'}/$in{'id'}/$_" && !-f "$SET{'USER_DIR'}/$_" && !-f "$SET{'USER_DIR'}/$in{'id'}/BF.bfa" && !-f "$SET{'USER_DIR'}/BF.bfa") {
			## ե뤬̵
			$check->{$_}->{'status'} = "NG";
			$check->{$_}->{'value'} = "Not found<b>$_</b>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}/$_" && !-r "$SET{'USER_DIR'}/$_" && !-r "$SET{'USER_DIR'}/$in{'id'}/BF.bfa" && !-r "$SET{'USER_DIR'}/BF.bfa") {
			## ѡߥå󤬴ְäƤ
			$check->{$_}->{'status'} = "NG";
			$check->{$_}->{'value'} = "Permission denied:<b>$_</b>";
		} else {
			if (-f "$SET{'USER_DIR'}/$in{'id'}/$_" && -r "$SET{'USER_DIR'}/$in{'id'}/$_") {
				## ե(ȥե/BF.*)
				$check->{$_}->{'value'} = "$SET{'USER_DIR'}/$in{'id'}/$_";
			} elsif (-f "$SET{'USER_DIR'}/$_" && -r "$SET{'USER_DIR'}/$_") {
				## ե(Хե/BF.*)
				$check->{$_}->{'value'} = "$SET{'USER_DIR'}/$_";
			} elsif (&_open('line',"$SET{'USER_DIR'}/$in{'id'}/$_")) {
				## ե(ȥե/BF.bfa)
				$check->{$_}->{'value'} = "$SET{'USER_DIR'}/$in{'id'}/BF.bfa";
			} elsif (&_open('line',"$SET{'USER_DIR'}/$_")) {
				## ե(Хե/BF.*)
				$check->{$_}->{'value'} = "$SET{'USER_DIR'}/BF.bfa";
			} else {
				## Ϥե뤬̵
				$check->{$_}->{'status'} = "NG";
				$check->{$_}->{'value'} = "Not found<b>$_</b>";
			}
		}
	}

	## jcode.plNKFγǧ
	$check->{'Code filter'}->{'status'} = "OK";
	if ($init{'code'}) {
		if ($SET{'NKF'}) {
			$check->{'Code filter'}->{'value'} = "$SET{'NKF'}";
		} elsif ($SET{'JCODE'}) {
			$check->{'Code filter'}->{'value'} = &_path($SET{'JCODE'});
		}
	} else {
		$check->{'Code filter'}->{'status'} = "NG";
	}

	$tmp2 = 0;
	foreach (sort keys %{$check}) {
		$check->{$_}->{'value'} ||= "&nbsp;";
		if ($check->{$_}->{'status'} eq 'NG') {
			$check->{$_}->{'status'} = "<b style=\"color:#ff0000\">NG</b>";
			$tmp2 ++;
		}
		$print .= "<tr>	<th>$_</th>	<th>$check->{$_}->{'status'}</th>	<td>$check->{$_}->{'value'}</td>	</tr>\n";
	}
	$print = "<b>$tmp2</b> of status are NG.\n<table border=1>$print</table>\n";


	if (-f "$SET{'USER_DIR'}/$in{'id'}/index") { &status; }

	undef @_;
}

sub help {

	my ($tmp1);

	$tmp1 = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.help$browser->{browser}","$SET{'USER_DIR'}/BF.help$browser->{browser}");

	&change($tmp1,\%print);
	undef %print;

	&do($tmp1);

	$print = $tmp1;

	$do{'nocache'} = 1;

	&print;

}

##
## Language Ver1.00
##
sub language {

	$SET{'LANGUAGE'} ||= (lc($ENV{'HTTP_ACCEPT_LANGUAGE'}) || "ja");
	&setting(\%TEXT,"$SET{'USER_DIR'}/.language/$SET{'LANGUAGE'}","$SET{'USER_DIR'}/.language/default");

}

##
## Setting Ver1.01
##
sub setting {

	my ($tmp1,$tmp2);
	$tmp1 = shift @_;
	foreach (@_) {
		if (-f $_) {
			foreach $tmp2 (&_open('file',$_)) {
				chomp ($tmp2);
				if ($tmp2 =~ /^\s*#/o) { next; }
				($tmp2) = split (/#\s+/,$tmp2);
				($tmp2) = split (/\s+#/,$tmp2);
				if (!$tmp2) { next; }
				if ($tmp2 =~ /\s*([^\s]+?)\s+(.*?)\s*$/gio) {
					${$tmp1}{uc($1)} = $2;
				} elsif ($tmp2 =~ /\s*([^\s]+?)\s*$/gio) {
					${$tmp1}{uc($1)} = "";
				}
			}
		}
	}
	undef @_;
	return;
}

##
## Decode Ver1.02
##
sub decode {

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7,$tmp8,$tmp9);
	$tmp1 = $ENV{'REQUEST_METHOD'};
	$tmp2 = $ENV{'QUERY_STRING'};
	$tmp3 = $ENV{'CONTENT_LENGTH'};

	if ($tmp1 eq "POST") {
		read(STDIN, $tmp7, $tmp3);
	} elsif ($tmp1 eq 'HEAD') {
		$tmp7 = $tmp2;
		$do{'nobody'} = 1;
	} else {
		$tmp7 = $tmp2;
	}

	$tmp7 ||= $ARGV[0];
	$in{'id'} = $tmp7;

	## For multipart formdata(Fileupload)
	if ($ENV{'CONTENT_TYPE'} =~ /^multipart\/form-data; boundary=-*(.*)$/) {
		$tmp4 = $1;
		foreach (split(/-*$tmp4-*[(\r\n)\n\r]+/,$tmp7)) {
			($tmp5,$tmp6) = split(/\r\n\r\n|\n\n|\r\r/,$_,2);
			$tmp6 =~ s/[(\r\n)\n\r]$//go;
			if ($tmp5 =~ s/Content-Disposition: form-data; name="(.*?)"; filename="(.*?)"[(\r\n)\n\r]+//) {
				push (@Query,"$1=$2");
				if ($tmp6 !~ /^[(\r\n)\n\r]?$/) {
					$files{$1} = "$tmp5\n";
					$files{$1} .= "Accept-Ranges: bytes\n";
					$files{$1} .= "Content-Length: " . length($tmp6) . "\n";
					$files{$1} .= "Last-Modified: " . &_http_time(time) . "\n";
					$files{$1} .= "\n";
					$files{$1} .= $tmp6;
				}
			} elsif ($tmp5 =~ /Content-Disposition: form-data; name="(.*?)"/) {
				push (@Query,"$1=$tmp6");
			}
		}
	} else {
		@Query = split('&', $tmp7);
	}

	push (@Query,@ARGV);

	foreach (@Query) {

		if (index($_,"=") < 0) { next; }

		($tmp8,$tmp9) = split(/=/, $_, 2);
		$tmp9 =~ tr/+/ /;
		$tmp8 =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;
		$tmp9 =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;

		if ($tmp8 =~ /nd\.(.+)/o) {
			$tmp8 = $1;
			$tmp9 =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;
		} elsif ($tmp8 =~ /file\.(.+)/o) {
			$tmp8 = $1;
			$tmp9 =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;
			$files{$tmp8} = $tmp9;
			$tmp9 = $1;
		}

		$tmp9 =~ s/&/&amp;/go;
		$tmp9 =~ s/</&lt;/go;
		$tmp9 =~ s/>/&gt;/go;
		$tmp9 =~ s/"/&quot;/go;
		$tmp9 =~ s/\r\n?/\n/go;
		$tmp9 =~ s/\\/\\\\/go;

		if ($in{$tmp8} && $tmp8 ne 'id') {
			$in{$tmp8} .= "&$tmp9";
		} else {
			$in{$tmp8} = $tmp9;
		}

	}

	undef @_;

}

sub error {

	if ($init{'error'}) { exit(1); }
	$init{'error'} = 1;
	$do{'nocache'} = 1;

	$error = {
		"01" => {
			key => "ERROR CODE",
			value => (caller)[2] . '@' . (caller)[1]
		},
		"02" => {
			key => "PID",
			value => $$
		},
		"03" => {
			key => "UID",
			value => $<
		},
		"04" => {
			key => "EUID",
			value => $>
		},
		"05" => {
			key => "GID",
			value => $(
		},
		"06" => {
			key => "EGID",
			value => $)
		},
		"07" => {
			key => "OS NAME",
			value => $^O
		},
		"08" => {
			key => "PROGRAM NAME",
			value => $0
		},
		"09" => {
			key => "PERL VERSION",
			value => $]
		},
		"10" => {
			key => "DEBUGGING",
			value => $^A
		},
		"11" => {
			key => "BASETIME",
			value => $^T
		},
		"12" => {
			key => "EXEC NAME",
			value => $^X
		},
	};

	$email{'error_code'} = $error->{'01'}->{value};

	undef $print;

	&change($_[0]);
	if ($_[0]) { $print .= "<b>ERROR:</b> $_[0]\n<br>\n<br>\n"; }
	$print .= "$TEXT{'ERROR_1'}\n<br>\n";
	$print .= "$TEXT{'ERROR_2'}\n<br>\n";
	$print .= "<table border=1 style=\"font-size:smaller\">\n";
	foreach (sort keys %{$error}) {
		$print .= "<tr><th>$error->{$_}->{key}</th><td>$error->{$_}->{value}</td></tr>\n";
		$email{'error'} .= sprintf("%-20s%-s\n",$error->{$_}->{key},$error->{$_}->{value});
	}
	foreach (sort keys %SET) {
		$email{'setting'} .= sprintf("%-20s%-s\n",$_,$SET{$_});
	}
	foreach (sort keys %in) {
		my ($tmp1);
		$tmp1 = uc ($_);
		$print .= "<tr><th>$tmp1</th><td>$in{$_}</td></tr>\n";
		$email{'query'} .= sprintf("%-20s%-s\n",$tmp1,$in{$_});
	}
	foreach (sort keys %ENV) {
		$email{'env'} .= sprintf("%-25s%-s\n",$_,$ENV{$_});
	}
	$print .= "</table>";

	$email{'url'} = $url;
	&sendmail(&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.email.error$browser->{browser}","$SET{'USER_DIR'}/BF.email.error$browser->{browser}"),\%email);

	$print =~ s/\\/\\\\/go;

	&print;

}

sub print {
	$head = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.head$browser->{browser}","$SET{'USER_DIR'}/BF.head$browser->{browser}") || "<html><head><title></title></head><body>";
	$foot = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.foot$browser->{browser}","$SET{'USER_DIR'}/BF.foot$browser->{browser}") || "</body></html>";
	my ($tmp1,$tmp2);

	if (!$do{'nohead'}) { $print = $head . $print . $foot; }
	&_default;

	$notice .= &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.notice$browser->{browser}","$SET{'USER_DIR'}/BF.notice$browser->{browser}");
	$notice =~ s/(.+?)\n/<li>$1<\/li>\n/go;
	$notice = "\n<ul>\n" . $notice . "\n</ul>\n";

	&do($print);
	&_transpose($print);
	&change($print);
	$print =~ s/(<form .*?action=(["']?)($cgi|{cgi})\2.*?>)(.*?)\n/$1$4\n<input type="hidden" name="id" value="$in{'id'}" \/>\n<input type="hidden" name="t" value="$in{'t'}" \/>\n<input type="hidden" name="v" value="$in{'v'}" \/>\n<input type="hidden" name="f" value="r" \/>\n<input type="hidden" name="cc" value="" \/>\n/gio;
	$print =~ s/<form (.*?)action=(["']?)($cgi|{cgi})\2(.*?)>(.*?)<\/form>/&_form/egios;
	$print =~ s/\\{/\{/go;
#	$print =~ s/([^\\])\\([^\\])/$1$2/go;
	$print =~ s/\\\\/\\/go;

	&_analysis(\%status,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/status"));
	if (!($status{'thread'} && $status{'log'} && $status{'date'}) && -f "$SET{'USER_DIR'}/$in{'id'}/index") { &status; }
	&_time($status{'date'});
	&_replace(\$print,'THREAD',$status{'thread'});
	&_replace(\$print,'LOG',$status{'log'});
	&_replace(\$print,'DATE',$status{'date'});
	&_replace(\$print,'VERSION',$version);
	&_replace(\$print,'ADDRESS',"<a $browser->{href}=\"mailto:" . $SET{'ADDRESS'} . '">' . $SET{'ADDRESS'} . '</a>');

	## Cross Site Scripting
	&_xss($print);

	if ($code[1]) { &code(\$print,$code[1]); }

	$tmp2 = "<!-- Time: " . (sprintf "%.2f", ((times)[0] - $time{'start'})) . " -->\n";
	$tmp2 .= "<!-- Admin: $SET{'ADDRESS'} -->\n";
	$tmp2 .= "<!-- Version: $revision -->\n";
	foreach (keys %WARNING) {
		$WARNING{$_} =~ s/\n//go;
		$tmp2 .= "<!-- Warning: $_ ($WARNING{$_}) -->\n";
		warn("$_ ($WARNING{$_})");
	}
	foreach (keys %plugin) {
		$tmp2 .= "<!-- Plugin: $_ ($plugin{$_}) -->\n";
	}
	if ($SET{'CACHE_DO'} ne 'N' && $ENV{'QUERY_STRING'} && !$do{'nocache'}) {
		$tmp2 .= "<!-- Cache: " . &_http_time($time) . " -->\n";
	}

	$print =~ s/(<\w.*>)/$1\n$tmp2/;

	select (STDOUT);

	$header .= "Content-Type: $browser->{content}; charset=$code[0]\n";
	$header .= "Accept-Ranges: bytes\n";
#	$header .= "Content-Length: " . (length($print) + 40) . "\n";
	$header .= "Content-Length: " . (length($print) + 20) . "\n";
	$header .= "Last-Modified: " . &_http_time($time) . "\n";
	$print = $header . "\n" . $print;

	if ($do{'nobody'}) {
		print $header . "\n";
	} elsif(!$do{'noprint'}) {
		## (R)
		$packed = pack("C*","36","112","114","105","110","116","32","61","126","32","115","47","60","116","105","116","108","101","40","46","42","63","41","62","40","46","42","63","41","60","92","47","116","105","116","108","101","62","47","60","116","105","116","108","101","36","49","62","66","46","70","111","114","117","109","32","58","32","36","50","32","45","32","36","118","101","114","115","105","111","110","60","92","47","116","105","116","108","101","62","47","105","59","112","114","105","110","116","32","36","112","114","105","110","116","59");
		eval ($packed);
	}

	if ($SET{'CACHE_DO'} ne 'N' && $ENV{'QUERY_STRING'} && !$do{'nocache'}) {
		## å
		$tmp1 = join('&',@Query);
		$tmp1 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
		$init{'error'} = 1;
		&_write(("$SET{'USER_DIR'}/.cache/$tmp1$browser->{browser}"),$print);
	}

	undef @_;
	exit(0);
}

1;
